!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs matrix that represents the Beltrami linear system.

!latex \heading{gauge and boundary conditions}

!latex \item The helicity integral, $\int {\bf A}\cdot{\bf B}\, dv$, depends explicity on the vector potential.
!latex The gauge must be constrained and the boundary conditions enforced.

!latex First we consider an annular volume.

!latex \heading{annular volume - gauge}

!latex \item The coordinates, $(\s,\t,\z)$, are adapted to the interfaces, so that the interfaces coincide with coordinate surfaces $s=const.$
!latex and $\t$,$\z$ are poloidal and toroidal angles.

!latex \item In the \mbox{$l$}-th annulus, bounded by the \mbox{$(l-1)$}-th and \mbox{$l$}-th interfaces,
!latex a general covariant representation of the magnetic vector-potential is written
!latex \be {\bf \bar A}=\bar A_{s} \nabla s + \bar A_{\t} \nabla \t + \bar A_{\z} \nabla \z. \ee
!latex To this add \mbox{$\nabla g(s,\t,\z)$}, where $g$ satisfies
!latex \be \partial_\s g(\s      ,\t,\z)  =  - \bar A_{\s}(\s      ,\t,\z)             ,\;\;
!latex     \partial_\t g(\s_{l-1},\t,\z)  =  - \bar A_{\t}(\s_{l-1},\t,\z)+\psi_{t,l-1},\;\;
!latex     \partial_\z g(\s_{l-1}, 0,\z)  =  - \bar A_{\z}(\s_{l-1}, 0,\z)+\psi_{p,l-1}, \ee
!latex for arbitrary constants \mbox{$\psi_{t,l-1}$}, \mbox{$\psi_{p,l-1}$}, which are the toroidal and poloidal-fluxes on the interior of surface \mbox{$l-1$}.
!latex Then \mbox{${\bf A}={\bf \bar A}+\nabla g$} is given by \mbox{${\bf A}=A_{\t}\nabla\t+A_{\z}\nabla\z$} with
!latex \be A_{\t}(\s_{l-1},\t,\z) = \psi_{t,l-1},\;\;
!latex     A_{\z}(\s_{l-1}, 0,\z) = \psi_{p,l-1}. \label{eq:gauge} \ee
!latex This specifies the gauge.

!latex \item The magnetic field is $\sqrt g {\bf B} = (\partial_\t A_\z - \partial_\z A_\t){\bf e}_\s - \partial_\s A_\z {\bf e}_\t + \partial_\s A_\t {\bf e}_\z$.
!latex \be  B^2            &=& B^\s B^\s g_{\s\s} + 2 B^\s B^\t g_{\s\t} + 2 B^\s B^\z g_{\s\z} + B^\t B^\t g_{\t\t} + 2 B^\t B^\z g_{\t\z} + B^\z B^\z g_{\z\z}\\
!latex \sqrt g {\bf A} \cdot {\bf B} &=& -A_\t \partial_s A_\z + A_\z \partial_s A_\t.
!latex \ee

!latex \item For stellarator symmetric equilibria, \mbox{$A_{\t}$} and \mbox{$A_{\z}$} may be represented by cosine series
!latex \be A_{\t}(s,\t,\z) = \sum_{j}A_{\t,j}(s)\cos(m_j\t-n_j\z),\;\;
!latex     A_{\z}(s,\t,\z) = \sum_{j}A_{\z,j}(s)\cos(m_j\t-n_j\z),\ee
!latex where \mbox{$A_{\t,j}(s)$} and \mbox{$A_{\z,j}(s)$} are represented using finite-elements, as described below.

!latex \item Within each annulus, a regular, radial-sub-grid, $s_{l,i} \equiv$ \verb+ss(l)%s(i)+, for $i=0,$ \verb+Ni+, is established, see \verb+al00aa+.

!latex \heading{interface boundary condition}

!latex \item The condition that the field is tangential to the inner interface is
!latex \be -m_jA_{\z,j}(s_{l-1})-n_jA_{\t,j}(s_{l-1})=0. \label{eq:innersurfaceconstraint} \ee
!latex Combing the gauge constraints and the flux surface condition we have
!latex \be A_{\t,j}(s_{l-1}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{t,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \label{eq:innergaugeAt}\ee
!latex \be A_{\z,j}(s_{l-1})  = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{p,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \label{eq:innergaugeAz}\ee

!latex \item The condition that the field is tangential to the outer interface is similar to \Eqn{innersurfaceconstraint}, but it cannot be simplified further and so
!latex at the outer interface we must constrain the vector potential to be of the form
!latex \be A_{\t}(s_{l}) = \partial_\t f(\t,\z) \, , \,\,\, A_{\z}(s_l) = \partial_\z f(\t,\z), \label{eq:outersurfaceconstraint} \ee
!latex for arbitrary \mbox{$f$} of the form
!latex \be f=\psi_{t,l} \t + \psi_{p,l} \z + \sum_j f_{l,j}\sin(m_j \t - n_j \z) \ee
!latex and \mbox{$\psi_{t,l}\equiv A_{\t,1}(s_l)$} and \mbox{$\psi_{p,l}\equiv A_{\z,1}(s_l)$}.
!latex We have
!latex \be A_{\t,j}(s_{l}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{t,l} & j=1, \\  m_j  f_{l,j} & j>1, \end{array} \right. \label{eq:outergaugeAt}\ee
!latex \be A_{\z,j}(s_{l}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{p,l} & j=1, \\ -n_j  f_{l,j} & j>1, \end{array} \right. \label{eq:outergaugeAz}\ee

!latex \heading{finite element radial basis functions}

!latex \item Within each annulus a regular, radial-sub-grid, $s_i$, is established.

!latex \item In the region $ s \in [ s_{i-1} , s_{i} ] $, the vector potential is ${\bf A}=A_\t \nabla \t + A_\z \nabla \z$ where
!latex \be A_{\t}(s,\t,\z) = \sum_{j,l,p} \, A_{\t,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) ,\\
!latex     A_{\z}(s,\t,\z) = \sum_{j,l,p} \, A_{\z,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) ,\ee
!latex where $j$ labels the Fourier harmonic, and $l=0,1$ and $p$ identify the radial basis functions, $\varphi_{l,p}(s)$.

!latex \item Near the coordinate singularity (described in more detail below) this representation needs to be modified.

!latex \heading{metric information}

!latex \item The geometric information required in the following is
!latex \be \bar g_{\s\s} \equiv g_{\s\s} / \sqrt g = \sum_i \bar g_{\s\s,i}(s)\cos(m_i\t-n_i\z), \\
!latex     \bar g_{\s\t} \equiv g_{\s\t} / \sqrt g = \sum_i \bar g_{\s\t,i}(s)\sin(m_i\t-n_i\z), \\
!latex     \bar g_{\s\z} \equiv g_{\s\z} / \sqrt g = \sum_i \bar g_{\s\z,i}(s)\sin(m_i\t-n_i\z), \\
!latex     \bar g_{\t\t} \equiv g_{\t\t} / \sqrt g = \sum_i \bar g_{\t\t,i}(s)\cos(m_i\t-n_i\z), \\
!latex     \bar g_{\t\z} \equiv g_{\t\z} / \sqrt g = \sum_i \bar g_{\t\z,i}(s)\cos(m_i\t-n_i\z), \\
!latex     \bar g_{\z\z} \equiv g_{\z\z} / \sqrt g = \sum_i \bar g_{\z\z,i}(s)\cos(m_i\t-n_i\z). \ee

!latex \item For any function \mbox{$f(\s,\t,\z)$}, in particular the metrics, we write
!latex \be \braket{s_j}{f}{s_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \sin(m_k\t-n_k\z) \nonumber \\
!latex     \braket{s_j}{f}{c_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \\
!latex     \braket{c_j}{f}{c_k} \! & \! = \! & \ooint \cos(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \ee

!latex \heading{volume integral}

!latex \item Consider the integral $P = \sum_{i=1}^{N_i}P_i$, where

!latex \be \begin{array}{ccccrrrr}
!latex P_i & = \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\t A_{\z} & \bar g_{\s\s} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex     &   & + & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex     &   & + & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\z} & \bar g_{\t\t} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\t} & \bar g_{\t\z} \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\t} & \partial_\s A_{\t} & \bar g_{\z\z} \\
!latex     &   & + & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} & \partial_\s A_{\z} &               \\
!latex     &   & - & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} & \partial_\s A_{\t} & .
!latex \end{array} \ee

!latex \heading{derivatives of volume integral -- annular regions}

!latex \item The first derivatives are as follows:

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\z\z} \\
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}   & c_j &               \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} &     & \varphi_{l,p}'  & c_j & 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} &     & \varphi_{l,p}'  & c_j &               \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}   & c_j & 
!latex \end{array} \ee

!latex \item The second derivatives are required for construction of the Beltrami matrix, which are given

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\z\z}}{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\t}}{c_k}
!latex \end{array} \ee

!latex \heading{matrix elements -- annular regions}

!latex \item The required matrix elements take the form, where $\a=\t,\z$ and $\b=\t,\z$,
!latex \be \begin{array}{ccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!latex \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i  } \\
!latex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!latex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i  } &+&
!latex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i+1} \\
!latex \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!latex                                               &                                             &         & &
!latex \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i+1} \\
!latex \end{array} \ee

!l!tex \heading{magnetic pressure}

!l!tex \item Consider the volume integral:

!l!tex \be P 

!l!tex &=& \int ds \ooint \frac{1}{2} \sqrt g B^2 \\

!l!tex &= \frac{1}{2} & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\t A_{\z} \partial_\t A_{\z} \,\, \bar g_{\s\s} \\
!l!tex &-             & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\t A_{\z} \partial_\z A_{\t} \,\, \bar g_{\s\s} \\
!l!tex &+ \frac{1}{2} & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\z A_{\t} \partial_\z A_{\t} \,\, \bar g_{\s\s} \\

!l!tex &-             & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\t A_{\z} \partial_\s A_{\z} \,\, \bar g_{\s\t} \\
!l!tex &+             & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\z A_{\t} \partial_\s A_{\z} \,\, \bar g_{\s\t} \\

!l!tex &+             & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\t A_{\z} \partial_\s A_{\t} \,\, \bar g_{\s\z} \\
!l!tex &-             & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\z A_{\t} \partial_\s A_{\t} \,\, \bar g_{\s\z} \\

!l!tex &+ \frac{1}{2} & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\s A_{\z} \partial_\s A_{\z} \,\, \bar g_{\t\t} \\
!l!tex &-             & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\s A_{\z} \partial_\s A_{\t} \,\, \bar g_{\t\z} \\
!l!tex &+ \frac{1}{2} & \sum_{i=1}^{N_i} \intdsl \ooint \partial_\s A_{\t} \partial_\s A_{\t} \,\, \bar g_{\z\z}.
!l!tex \ee

!l!tex For given geometry, this is a quadratic function of the $A_{\t,j,i,p}$ and the $A_{\z,j,i,p}$.
!l!tex The matrix to be constructed is comprised of the second derivatives of $P$ with respect to the $A_{\t,j,i,p}$ and the $A_{\z,k,o,q}$.

!l!tex \item The $A_{\t,j,0,0}$ and $A_{\z,j,0,0}$ are not degrees of freedom. 
!l!tex These terms, which are related to the toroidal and poloidal fluxes, contribute to the `right-hand-side'.
!l!tex Also, the $A_{\t,j,N_i,0}$ and $A_{\z,j,N_i,0}$ are not independent.
!l!tex \item The outer interface boundary condition requires that 
!l!tex \be A_{\t,j,N_i,0} =  m_j f_{j}, \,\,\,\,\,\,\,\, A_{\z,j,N_i,0} = -n_j f_{j}, \ee
!l!tex for $j>1$, where the $f_j$ are independent degrees of freedom.
!l!tex The $A_{\t,1,N_i,0}$ and $A_{\z,1,N_i,0}$ are not degrees of freedom (and again contribute to the `right-hand-side').

!l!tex \heading{first derivative with respect to $a \equiv A_{\t,j,i,p}$ }

!l!tex \item The first derivative with respect to $a \equiv A_{\t,j,i,p}$ is 

!l!tex \be 
!l!tex \frac{\partial P}{\partial a} &=& \\
!l!tex &-& \intdsl \ooint n_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\t A_{\z} \, \bar g_{\s\s}
!l!tex  -  \intdsu \ooint n_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\t A_{\z} \, \bar g_{\s\s} \\
!l!tex &+& \intdsl \ooint n_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\z A_{\t} \, \bar g_{\s\s}
!l!tex  +  \intdsu \ooint n_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\z A_{\t} \, \bar g_{\s\s} \\
!l!tex &+& \intdsl \ooint n_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\s A_{\z} \, \bar g_{\s\t}
!l!tex  +  \intdsu \ooint n_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\s A_{\z} \, \bar g_{\s\t} \\
!l!tex &+& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\t A_{\z} \, \bar g_{\s\z}
!l!tex  +  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\t A_{\z} \, \bar g_{\s\z} \\
!l!tex &-& \intdsl \ooint n_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\s A_{\t} \, \bar g_{\s\z}
!l!tex  -  \intdsu \ooint n_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\s A_{\t} \, \bar g_{\s\z} \\
!l!tex &-& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\z A_{\t} \, \bar g_{\s\z}
!l!tex  -  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\z A_{\t} \, \bar g_{\s\z} \\
!l!tex &-& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\s A_{\z} \, \bar g_{\t\z}
!l!tex  -  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\s A_{\z} \, \bar g_{\t\z} \\
!l!tex &+& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\s A_{\t} \, \bar g_{\z\z}
!l!tex  +  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\s A_{\t} \, \bar g_{\z\z}
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\t,k,i-1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, n_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &-& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}  \,\, n_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\z\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\t,k,i  ,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, n_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k}   
!l!tex  +  \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, n_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &-& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k}   
!l!tex  -  \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, n_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k}   
!l!tex  -  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}  \,\, n_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\z\z}}{c_k} 
!l!tex  +  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\z\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\t,k,i+1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, n_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &-& \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex &-& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, n_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex &+& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\z\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\z,k,i-1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, m_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}  \,\, m_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\z,k,i  ,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, m_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k}
!l!tex  +  \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, m_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsl \,\, n_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k}
!l!tex  +  \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, m_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k}
!l!tex  -  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}  \,\, m_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex  -  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\z,k,i+1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, m_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsu \,\, n_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex &-& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, m_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex &-& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex \ee

!l!tex \heading{first derivative with respect to $a \equiv A_{\z,j,i,p}$ }

!l!tex \item The first derivative with respect to $a \equiv A_{\z,j,i,p}$ is 

!l!tex \be 
!l!tex \frac{\partial P}{\partial a} &=& \\
!l!tex &-& \intdsl \ooint m_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\t A_{\z} \, \bar g_{\s\s}
!l!tex  -  \intdsu \ooint m_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\t A_{\z} \, \bar g_{\s\s} \\
!l!tex &+& \intdsl \ooint m_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\z A_{\t} \, \bar g_{\s\s}
!l!tex  +  \intdsu \ooint m_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\z A_{\t} \, \bar g_{\s\s} \\
!l!tex &+& \intdsl \ooint m_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\s A_{\z} \, \bar g_{\s\t}
!l!tex  +  \intdsu \ooint m_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\s A_{\z} \, \bar g_{\s\t} \\
!l!tex &-& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\t A_{\z} \, \bar g_{\s\t}
!l!tex  -  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\t A_{\z} \, \bar g_{\s\t} \\
!l!tex &+& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\z A_{\t} \, \bar g_{\s\t}
!l!tex  +  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\z A_{\t} \, \bar g_{\s\t} \\
!l!tex &-& \intdsl \ooint m_j        \, \sin\alpha_j \, \varphi_{1,p}  \, \partial_\s A_{\t} \, \bar g_{\s\z}
!l!tex  -  \intdsu \ooint m_j        \, \sin\alpha_j \, \varphi_{0,p}  \, \partial_\s A_{\t} \, \bar g_{\s\z} \\
!l!tex &+& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\s A_{\z} \, \bar g_{\t\t}
!l!tex  +  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\s A_{\z} \, \bar g_{\t\t} \\
!l!tex &-& \intdsl \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{1,p}' \, \partial_\s A_{\t} \, \bar g_{\t\z}
!l!tex  -  \intdsu \ooint \,\,\,\,\, \, \cos\alpha_j \, \varphi_{0,p}' \, \partial_\s A_{\t} \, \bar g_{\t\z}
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\t,k,i-1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, n_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}  \,\, n_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex &-& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\t,k,i  ,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, n_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k}   
!l!tex  +  \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, n_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, n_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k}   
!l!tex  +  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, n_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex &-& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k}   
!l!tex  -  \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex &-& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex  -  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\t,k,i+1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, n_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, n_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex &-& \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex &-& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\t\z}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\z,k,i-1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, m_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}  \,\, m_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\t\t}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\z,k,i  ,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, m_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k}
!l!tex  +  \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, m_k          \,\, \varphi_{0,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsl \,\, m_j          \,\, \varphi_{1,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k}
!l!tex  +  \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, m_k          \,\, \varphi_{1,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k}
!l!tex  +  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}  \,\, m_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex &+& \intdsl \,\, \,\,\,\,\,\, \,\, \varphi_{1,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\t\t}}{c_k} 
!l!tex  +  \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{0,q}' \,\, \braket{c_j}{\bar g_{\t\t}}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\z,k,i+1,q}$ is

!l!tex \be
!l!tex \frac{\partial^2 P}{\partial a \partial b} &=& \\
!l!tex &+& \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, m_k          \,\, \varphi_{1,q}  \,\, \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex &+& \intdsu \,\, m_j          \,\, \varphi_{0,p}  \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex &+& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}  \,\, m_k          \,\, \varphi_{0,p}' \,\, \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex &+& \intdsu \,\, \,\,\,\,\,\, \,\, \varphi_{0,p}' \,\, \,\,\,\,\,\, \,\, \varphi_{1,q}' \,\, \braket{c_j}{\bar g_{\t\t}}{c_k} 
!l!tex \ee

!l!tex \heading{helicity}

!l!tex \item Consider the volume integral:

!l!tex \be H 

!l!tex &=& \frac{1}{2} \int ds \ooint \sqrt g {\bf A} \cdot {\bf B} \\

!l!tex &=& \frac{1}{2} \sum_{i=1}^{N_i} \intdsl \ooint    
!l!tex \left[ - A_{\t} \partial_\s A_{\z} + A_{\z} \partial_\s A_{\t} \right].
!l!tex \ee

!l!tex \heading{first derivative with respect to $a \equiv A_{\t,j,i,p}$ }

!l!tex \item The first derivative with respect to $a \equiv A_{\t,j,i,p}$ is 
!l!tex \be 
!l!tex \frac{\partial H}{\partial a} &=& \\
!l!tex &-& \frac{1}{2} \intdsl \ooint \cos\alpha_j \, \varphi_{1,p}  \, \partial_\s A_{\z}   
!l!tex  -  \frac{1}{2} \intdsu \ooint \cos\alpha_j \, \varphi_{0,p}  \, \partial_\s A_{\z} \\
!l!tex &+& \frac{1}{2} \intdsl \ooint \cos\alpha_j \, \varphi_{1,p}' \, \,\,\,\,\,  A_{\z}   
!l!tex  +  \frac{1}{2} \intdsu \ooint \cos\alpha_j \, \varphi_{0,p}' \, \,\,\,\,\,  A_{\z}
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\t,k,i-1,q}$, $b \equiv A_{\t,k,i  ,q}$ and $b \equiv A_{\t,k,i+1,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& 0.\\
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\z,k,i-1,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& \\
!l!tex &-& \frac{1}{2} \intdsl \varphi_{1,p}  \, \varphi_{0,q}' \, \braket{c_j}{1}{c_k} \\
!l!tex &+& \frac{1}{2} \intdsl \varphi_{1,p}' \, \varphi_{0,q}  \, \braket{c_j}{1}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\z,k,i  ,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& \\
!l!tex &-& \frac{1}{2} \intdsl \varphi_{1,p}  \, \varphi_{1,q}' \, \braket{c_j}{1}{c_k}
!l!tex  -  \frac{1}{2} \intdsu \varphi_{0,p}  \, \varphi_{0,q}' \, \braket{c_j}{1}{c_k} \\
!l!tex &+& \frac{1}{2} \intdsl \varphi_{1,p}' \, \varphi_{1,q}  \, \braket{c_j}{1}{c_k}
!l!tex  +  \frac{1}{2} \intdsu \varphi_{0,p}' \, \varphi_{0,q}  \, \braket{c_j}{1}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\t,j,i,p}$ and $b \equiv A_{\z,k,i+1,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& \\
!l!tex &-& \frac{1}{2} \intdsu \varphi_{0,p}  \, \varphi_{1,q}' \, \braket{c_j}{1}{c_k} \\
!l!tex &+& \frac{1}{2} \intdsu \varphi_{0,p}' \, \varphi_{1,q}  \, \braket{c_j}{1}{c_k}
!l!tex \ee

!l!tex \heading{first derivative with respect to $a \equiv A_{\z,j,i,p}$ }

!l!tex \item The first derivative with respect to $a \equiv A_{\z,j,i,p}$ is 
!l!tex \be 
!l!tex \frac{\partial H}{\partial a} &=& \\
!l!tex &-& \frac{1}{2} \intdsl \ooint \cos\alpha_j \, \varphi_{1,p}' \, \,\,\,\,\,  A_{\t}   
!l!tex  -  \frac{1}{2} \intdsu \ooint \cos\alpha_j \, \varphi_{0,p}' \, \,\,\,\,\,  A_{\t} \\
!l!tex &+& \frac{1}{2} \intdsl \ooint \cos\alpha_j \, \varphi_{1,p}  \, \partial_s  A_{\t}   
!l!tex  +  \frac{1}{2} \intdsu \ooint \cos\alpha_j \, \varphi_{0,p}  \, \partial_s  A_{\t}
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\t,k,i-1,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& \\
!l!tex &-& \frac{1}{2} \intdsl \varphi_{1,p}' \, \varphi_{0,q}  \, \braket{c_j}{1}{c_k} \\
!l!tex &+& \frac{1}{2} \intdsl \varphi_{1,p}  \, \varphi_{0,q}' \, \braket{c_j}{1}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\t,k,i  ,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& \\
!l!tex &-& \frac{1}{2} \intdsl \varphi_{1,p}' \, \varphi_{1,q}  \, \braket{c_j}{1}{c_k}
!l!tex  -  \frac{1}{2} \intdsu \varphi_{0,p}' \, \varphi_{0,q}  \, \braket{c_j}{1}{c_k} \\
!l!tex &+& \frac{1}{2} \intdsl \varphi_{1,p}  \, \varphi_{1,q}' \, \braket{c_j}{1}{c_k}
!l!tex  +  \frac{1}{2} \intdsu \varphi_{0,p}  \, \varphi_{0,q}' \, \braket{c_j}{1}{c_k} 
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\t,k,i+1,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& \\
!l!tex &-& \frac{1}{2} \intdsu \varphi_{0,p}' \, \varphi_{1,q}  \, \braket{c_j}{1}{c_k} \\
!l!tex &+& \frac{1}{2} \intdsu \varphi_{0,p}  \, \varphi_{1,q}' \, \braket{c_j}{1}{c_k}
!l!tex \ee

!l!tex \item The second derivative with respect to $a \equiv A_{\z,j,i,p}$ and $b \equiv A_{\z,k,i-1,q}$, $b \equiv A_{\z,k,i  ,q}$ and $b \equiv A_{\z,k,i+1,q}$ is
!l!tex \be
!l!tex \frac{\partial^2 H}{\partial a \partial b} &=& 0.\\
!l!tex \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!l!tex \heading{representation of vector potential}

!l!tex \item The helicity integral, $\int {\bf A}\cdot{\bf B}\,dv$, depends explicity on the vector potential.
!l!tex To work with the vector potential directly, the gauge must be constrained and boundary conditions enforced.

!l!tex \item The magnetic field is $\sqrt g {\bf B} = (\partial_\t A_\z - \partial_\z A_\t){\bf e}_\s - \partial_\s A_\z {\bf e}_\t + \partial_\s A_\t {\bf e}_\z$.
!l!tex \be  B^2            &=& B^\s B^\s g_{\s\s} + 2 B^\s B^\t g_{\s\t} + 2 B^\s B^\z g_{\s\z} + B^\t B^\t g_{\t\t} + 2 B^\t B^\z g_{\t\z} + B^\z B^\z g_{\z\z}\\
!l!tex \sqrt g {\bf A} \cdot {\bf B} &=& -A_\t \partial_s A_\z + A_\z \partial_s A_\t.
!l!tex \ee

!l!tex \heading{annular volume}
!l!tex \item First, consider an annulur volume.
!l!tex The condition that the field is tangential to the inner interface is
!l!tex \be -m_jA_{\z,l,j}(s_{l-1})-n_jA_{\t,l,j}(s_{l-1})=0. \label{eq:innerfluxsurface} \ee
!l!tex Combing the gauge constraints and the flux surface condition we have
!l!tex \be A_{\t,l,j}(s_{l-1}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{t,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \label{eq:innergaugeAt}\ee
!l!tex \be A_{\z,l,j}(s_{l-1})  = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{p,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \label{eq:innergaugeAz}\ee
!l!tex \item The condition that the field is tangential to the outer interface is similar to \Eqn{innerfluxsurface}, but there is no remaining gauge freedom to exploit.
!l!tex Instead, at the outer interface we must constrain the vector potential to be of the form
!l!tex \be A_{\t,l}(s_{l}) = \partial_\t f_l(\t,\z) \, , \,\,\, A_{\z,l}(s_l) = \partial_\z f_l(\t,\z), \label{eq:outerboundaryconstraint} \ee
!l!tex for arbitrary \mbox{$f$} of the form
!l!tex \be f_l=\psi_{t,l} \t + \psi_{p,l} \z + \sum_j f_{l,j}\sin(m_j \t - n_j \z) \ee
!l!tex and \mbox{$\psi_{t,l}\equiv A_{\t,l,1}(s_l)$} and \mbox{$\psi_{p,l}\equiv A_{\z,l,1}(s_l)$}.
!l!tex We have
!l!tex \be A_{\t,l,j}(s_{l}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{t,l} & j=1, \\  m_j  f_{l,j} & j>1, \end{array} \right. \label{eq:outergaugeAt}\ee
!l!tex \be A_{\z,l,j}(s_{l}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{p,l} & j=1, \\ -n_j  f_{l,j} & j>1, \end{array} \right. \label{eq:outergaugeAz}\ee

!l!tex \item The vector potential is ${\bf A}=A_\t \nabla \t + A_\z \nabla \z$ where
!l!tex \be A_{\t}(s,\t,\z) = \sum_{j,l,p} \, A_{\t,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) ,\\
!l!tex     A_{\z}(s,\t,\z) = \sum_{j,l,p} \, A_{\z,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) ,\ee

!latex \heading{gauge and regularity conditions near coordinate origin}

!latex \item Near the polar coordinate origin, which is {\em not} required to coincide with the magnetic axis (the location of which is as yet not known apriori),
!latex we may exploit the regularity constraints and gauge freedom \footnote{This was done using Mathematica, and further details will be provided on demand.} to write
!latex ${\bf A}=A_\t \nabla \t + A_\z \nabla \z$ where
!latex \be A_\t(s,\t,\z) &=& \sum_{j=1} \sum_{p=0} A_{\t,j,0,p} s^{m_j+2+2p} \cos(m_j\t -n_j\z), \\
!latex     A_\z(s,\t,\z) &=& \sum_{j=1} \sum_{p=0} A_{\z,j,0,p} s^{m_j\;\;\;\;\;+2p} \cos(m_j\t -n_j\z), 
!latex \ee
!latex where the $A_{\t,j,0,p}$ and $A_{\z,j,0,p}$ are degrees of freedom, except $A_{\z,j,0,0}=0$ if $m_j=0$.

!latex \item Note that the location of the coordinate axis is determined by \verb+ex00aa+.

!latex \item The factor $s^{m_j}$ can become very small and cause finite-precision errors unless it is treated carefully.
!latex Introducing the scaled independent variables
!latex \be a_{j,p} \equiv A_{\t,j,0,p} \; \rho^{m_j},\;\;\; b_{j,p} \equiv A_{\z,j,0,p} \; \rho^{m_j},\ee
!latex where $\rho \equiv s_{1,1}$, and for $s\in[0,\rho]$ we have
!latex \be A_\t(s,\t,\z) &=& \sum_{j=1} \sum_{p=0} a_{j,p} s^{m_j+2+2p}/\rho^{m_j} \cos(m_j\t -n_j\z), \\
!latex     A_\z(s,\t,\z) &=& \sum_{j=1} \sum_{p=0} b_{j,p} s^{m_j\;\;\;\;\;+2p}/\rho^{m_j} \cos(m_j\t -n_j\z), 
!latex \ee

!latex \heading{matching regularity/gauge at first grid}

!latex \item By matching at the first grid point, $\rho \equiv s_{1,1}$,
!latex we see that the $A_{\t,j,1,p}$ depend on the $a_{j,p}$ and the $A_{\z,j,1,p}$ depend on the $b_{j,p}$.

!latex \item For example, consider the quintic case, where \verb+Nofe+ $=2$.

!latex For the $A_{\t,j}$, matching at $s=\rho$ gives
!latex \be 
!latex \left( \begin{array}{c} A_{\t,j,1,0} \\ A_{\t,j,1,1} \\ A_{\t,j,1,2} \end{array} \right) = 
!latex \left( \begin{array}{rcrcr}
!latex             \rho^{2} &,&            \rho^{4} &,&            \rho^{6} \\
!latex       (m+2) \rho^{1} &,&      (m+4) \rho^{3} &,&      (m+6) \rho^{5} \\
!latex  (m+1)(m+2) \rho^{0} &,& (m+3)(m+4) \rho^{2} &,& (m+5)(m+6) \rho^{4}
!latex \end{array} \right)
!latex \left( \begin{array}{c} a_{j,0} \\ a_{j,1} \\ a_{j,2} \end{array} \right)
!latex \ee

!latex and for the $A_{\z,j}$ we have
!latex \be 
!latex \left( \begin{array}{c} A_{\z,j,1,0} \\ A_{\z,j,1,1} \\ A_{\z,j,1,2} \end{array} \right) =
!latex \left( \begin{array}{rcrcr}
!latex             \rho^{+0} &,&            \rho^{2} &,&            \rho^{4} \\
!latex       (m+0) \rho^{-1} &,&      (m+2) \rho^{1} &,&      (m+4) \rho^{3} \\
!latex  (m-1)(m+0) \rho^{-2} &,& (m+1)(m+2) \rho^{0} &,& (m+3)(m+4) \rho^{2}
!latex \end{array} \right)
!latex \left( \begin{array}{c} b_{j,0} \\ b_{j,1} \\ b_{j,2} \end{array} \right)
!latex \ee

!latex \item Whether linear, cubic, quintic or septemtic polynomials are used, we may write
!latex \be A_{\t,j,1,p}  =  \sum_{q=0}^{N} {\cal A}_{p,q}^j \, a_{j,q} \,\,\, , \,\,\,\,\,\,
!latex     A_{\z,j,1,p}  =  \sum_{q=0}^{N} {\cal B}_{p,q}^j \, b_{j,q}, \label{eq:matching}
!latex \ee
!latex where ${\cal A}_{p,q}^j \equiv$ \verb+Ajpq(j,p,q)+ and ${\cal B}_{p,q}^j \equiv$ \verb+Bjpq(j,p,q)+, which are assigned in \verb+al00aa+.

!l!tex \heading{volume integral}

!l!tex \item The metric information is given as
!l!tex \be \bar g_{\s\s} \equiv g_{\s\s} / \sqrt g = \sum_i \bar g_{\s\s,i}(s)\cos(m_i\t-n_i\z), \\
!l!tex     \bar g_{\s\t} \equiv g_{\s\t} / \sqrt g = \sum_i \bar g_{\s\t,i}(s)\sin(m_i\t-n_i\z), \\
!l!tex     \bar g_{\s\z} \equiv g_{\s\z} / \sqrt g = \sum_i \bar g_{\s\z,i}(s)\sin(m_i\t-n_i\z), \\
!l!tex     \bar g_{\t\t} \equiv g_{\t\t} / \sqrt g = \sum_i \bar g_{\t\t,i}(s)\cos(m_i\t-n_i\z), \\
!l!tex     \bar g_{\t\z} \equiv g_{\t\z} / \sqrt g = \sum_i \bar g_{\t\z,i}(s)\cos(m_i\t-n_i\z), \\
!l!tex     \bar g_{\z\z} \equiv g_{\z\z} / \sqrt g = \sum_i \bar g_{\z\z,i}(s)\cos(m_i\t-n_i\z). \ee

!l!tex \item For any function \mbox{$f(\s,\t,\z)$}, in particular the metrics, we write
!l!tex \be \braket{s_j}{f}{s_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \sin(m_k\t-n_k\z) \nonumber \\
!l!tex     \braket{s_j}{f}{c_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \\
!l!tex     \braket{c_j}{f}{c_k} \! & \! = \! & \ooint \cos(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \ee

!l!tex For given geometry, this is a quadratic function of the $A_{\t,j,i,p}$ and the $A_{\z,j,i,p}$.
!l!tex The matrix to be constructed is comprised of the second derivatives of $P$ with respect to the $A_{\t,j,i,p}$ and the $A_{\z,k,o,q}$.

!latex \item The $A_{\t,j,0,0}$ and $A_{\z,j,0,0}$ are not degrees of freedom. 
!latex These terms, which are related to the toroidal and poloidal fluxes, contribute to the `right-hand-side'.
!latex Also, the $A_{\t,j,N_i,0}$ and $A_{\z,j,N_i,0}$ are not independent.

!l!tex \item The outer interface boundary condition requires that 
!l!tex \be A_{\t,j,N_i,0} =  m_j f_{j}, \,\,\,\,\,\,\,\, A_{\z,j,N_i,0} = -n_j f_{j}, \ee
!l!tex for $j>1$, where the $f_j$ are independent degrees of freedom.
!l!tex The $A_{\t,1,N_i,0}$ and $A_{\z,1,N_i,0}$ are not degrees of freedom (and again contribute to the `right-hand-side').


!l!tex \item Consider the integral $P = \sum_{i=1}^{N_i}P_i$, where

!l!tex \be \begin{array}{ccccrrrr}
!l!tex P_i & = \\
!l!tex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\t A_{\z} & \bar g_{\s\s} \\
!l!tex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!l!tex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!l!tex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!l!tex     &   & + & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!l!tex     &   & + & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!l!tex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!l!tex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\z} & \bar g_{\t\t} \\
!l!tex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\t} & \bar g_{\t\z} \\
!l!tex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\t} & \partial_\s A_{\t} & \bar g_{\z\z} \\
!l!tex     &   & + & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} & \partial_\s A_{\z} &               \\
!l!tex     &   & - & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} & \partial_\s A_{\t} & .
!l!tex \end{array} \ee

!l!tex \heading{general derivatives}

!l!tex \item The first derivatives are as follows:

!l!tex \be \begin{array}{cccccrccccccccccc}
!l!tex \ds \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\z\z} \\
!l!tex     &   & + & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}   & c_j &               \\
!l!tex     &   & - & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} &     & \varphi_{l,p}'  & c_j & 
!l!tex \end{array} \ee

!l!tex \be \begin{array}{cccccrccccccccccc}
!l!tex \ds \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!l!tex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\t} \\
!l!tex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!l!tex     &   & + & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} &     & \varphi_{l,p}'  & c_j &               \\
!l!tex     &   & - & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}   & c_j & 
!l!tex \end{array} \ee

!l!tex \item The second derivatives are required for construction of the Beltrami matrix, which are given

!l!tex \be \begin{array}{cccccrccccccccccc}
!l!tex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!l!tex     &   & + &               & \ds \intdsl & n_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex     &   & - &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex     &   & - &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\z\z}}{c_k} 
!l!tex \end{array} \ee

!l!tex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!l!tex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!l!tex     &   & + &               & \ds \intdsl & m_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex     &   & + &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!l!tex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!l!tex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} \\
!l!tex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} 
!l!tex \end{array} \ee

!l!tex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!l!tex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!l!tex     &   & + &               & \ds \intdsl & n_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex     &   & + &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex     &   & - &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!l!tex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!l!tex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} \\
!l!tex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} 
!l!tex \end{array} \ee

!l!tex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!l!tex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!l!tex     &   & + &               & \ds \intdsl & m_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!l!tex     &   & + &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!l!tex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!l!tex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\t}}{c_k}
!l!tex \end{array} \ee

!l!tex \heading{general matrix elements}

!l!tex \item The required matrix elements take the form, where $\a=\t,\z$ and $\b=\t,\z$,
!l!tex \be \begin{array}{ccccccccccccccccccccccccccccc}
!l!tex \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!l!tex \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i  } \\
!l!tex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!l!tex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i  } &+&
!l!tex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i+1} \\
!l!tex \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!l!tex                                               &                                             &         & &
!l!tex \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i+1} \\
!l!tex \end{array} \ee

!latex \heading{derivatives near coordinate singularity}

!latex \item The innermost volume, $l=1$, contains the coordinate singularity, so for $l=1$ and $i=1$ the following expressions must be used.
!latex \item The first derivative with respect to $a \equiv a_{j,p}$ is, where $\bar s \equiv s/\rho$, 
!latex \be \begin{array}{clllccrr}
!latex \ds \frac{\partial P_1}{\partial a} \!\!\!\! &\!\!=\!\!&\!\! \\
!latex &-               & \ds \intdsp \ooint n_j & \sin\alpha_j &            & \bar s^{m_j} s^{2+2p+0} & \partial_\t A_{\z} & \bar g_{\s\s} \\
!latex &-               & \ds \intdsp \ooint n_j & \sin\alpha_j &            & \bar s^{m_j} s^{2+2p+0} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex &-               & \ds \intdsp \ooint n_j & \sin\alpha_j &            & \bar s^{m_j} s^{2+2p+0} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex &+               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2+2p) & \bar s^{m_j} s^{2+2p-1} & \partial_\t A_{\z} & \bar g_{\s\z} \\
!latex &+               & \ds \intdsp \ooint n_j & \sin\alpha_j &            & \bar s^{m_j} s^{2+2p+0} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex &-               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2+2p) & \bar s^{m_j} s^{2+2p-1} & \partial_\z A_{\t} & \bar g_{\s\z} \\
!latex &-               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2+2p) & \bar s^{m_j} s^{2+2p-1} & \partial_\s A_{\z} & \bar g_{\t\z} \\
!latex &+               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2+2p) & \bar s^{m_j} s^{2+2p-1} & \partial_\s A_{\t} & \bar g_{\z\z} \\
!latex &+ \frac{\mu}{2} & \ds \intdsp \ooint     & \cos\alpha_j &            & \bar s^{m_j} s^{2+2p+0} & \partial_\s A_{\z} &               \\
!latex &- \frac{\mu}{2} & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2+2p) & \bar s^{m_j} s^{2+2p-1} &             A_{\z} &                 
!latex \end{array} \ee

!latex \item The second derivative with respect to $a \equiv a_{j,p}$ and $b \equiv a_{k,q}$ is 
!latex \be \begin{array}{cclllccclc}
!latex \ds \frac{\partial^2 P_1}{\partial a \partial b} \!\!\!\! &\!\!=\!\!&\!\! \\
!latex &+               & \rho^{1+2+2p+0+2+2q+0} \ds \intdso n_j &            & \bs^{m_j} \bs^{2+2p+0} & n_k &            & \bs^{m_k} \bs^{2+2q+0} & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex &-               & \rho^{1+2+2p+0+2+2q-1} \ds \intdso n_j &            & \bs^{m_j} \bs^{2+2p+0} &     & (m_k+2+2q) & \bs^{m_k} \bs^{2+2q-1} & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex &-               & \rho^{1+2+2p-1+2+2q+0} \ds \intdso     & (m_j+2+2p) & \bs^{m_j} \bs^{2+2p-1} & n_k &            & \bs^{m_k} \bs^{2+2q+0} & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex &+               & \rho^{1+2+2p-1+2+2q-1} \ds \intdso     & (m_j+2+2p) & \bs^{m_j} \bs^{2+2p-1} &     & (m_k+2+2q) & \bs^{m_k} \bs^{2+2q-1} & \braket{c_j}{\bar g_{\z\z}}{c_k}
!latex \end{array} \ee

!latex \item The second derivative with respect to $a \equiv a_{j,p}$ and $b \equiv b_{k,q}$ is 
!latex \be \begin{array}{clllllcccclrc}
!latex \ds \frac{\partial^2 P_1}{\partial a \partial b} \!\!\!\! &\!\!=\!\!&\!\! \\
!latex &+               & \rho^{1+2+2p+0+0+2q+0} \ds \intdso n_j &            & \bs^{m_j} \bs^{2+2p+0} & m_k &            & \bs^{m_k} \bs^{2q+0} & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex &+               & \rho^{1+2+2p+0+0+2q-1} \ds \intdso n_j &            & \bs^{m_j} \bs^{2+2p+0} &     & (m_k+2q  ) & \bs^{m_k} \bs^{2q-1} & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex &-               & \rho^{1+2+2p-1+0+2q+0} \ds \intdso     & (m_j+2+2p) & \bs^{m_j} \bs^{2+2p-1} & m_k &            & \bs^{m_k} \bs^{2q+0} & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex &-               & \rho^{1+2+2p-1+0+2q-1} \ds \intdso     & (m_j+2+2p) & \bs^{m_j} \bs^{2+2p-1} &     & (m_k+2q  ) & \bs^{m_k} \bs^{2q-1} & \braket{c_j}{\bar g_{\z\z}}{c_k} \\
!latex &+ \frac{\mu}{2} & \rho^{1+2+2p+0+0+2q-1} \ds \intdso     &            & \bs^{m_j} \bs^{2+2p+0} &     & (m_k+2q  ) & \bs^{m_k} \bs^{2q-1} & \braket{c_j}{     1       }{c_k} \\
!latex &- \frac{\mu}{2} & \rho^{1+2+2p-1+0+2q+0} \ds \intdso     & (m_j+2+2p) & \bs^{m_j} \bs^{2+2p-1} &     &            & \bs^{m_k} \bs^{2q+0} & \braket{c_j}{     1       }{c_k}   
!latex \end{array} \ee

!latex \item The first derivative with respect to $a \equiv b_{j,p}$ is 
!latex \be \begin{array}{clllcccccrc}
!latex \ds \frac{\partial P_1}{\partial a} \!\!\!\! &\!\!=\!\!&\!\! \\
!latex &-               & \ds \intdsp \ooint m_j & \sin\alpha_j &            & \bs^{m_j} s^{0+2p+0} & \partial_\t A_{\z} & \bar g_{\s\s} \\
!latex &+               & \ds \intdsp \ooint m_j & \sin\alpha_j &            & \bs^{m_j} s^{0+2p+0} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex &+               & \ds \intdsp \ooint m_j & \sin\alpha_j &            & \bs^{m_j} s^{0+2p+0} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex &-               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2p  ) & \bs^{m_j} s^{0+2p-1} & \partial_\t A_{\z} & \bar g_{\s\t} \\
!latex &+               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2p  ) & \bs^{m_j} s^{0+2p-1} & \partial_\z A_{\t} & \bar g_{\s\t} \\
!latex &-               & \ds \intdsp \ooint m_j & \sin\alpha_j &            & \bs^{m_j} s^{0+2p+0} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex &+               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2p  ) & \bs^{m_j} s^{0+2p-1} & \partial_\s A_{\z} & \bar g_{\t\t} \\
!latex &-               & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2p  ) & \bs^{m_j} s^{0+2p-1} & \partial_\s A_{\t} & \bar g_{\t\z} \\
!latex &+ \frac{\mu}{2} & \ds \intdsp \ooint     & \cos\alpha_j & (m_j+2p  ) & \bs^{m_j} s^{0+2p-1} &             A_{\t} &               \\
!latex &- \frac{\mu}{2} & \ds \intdsp \ooint     & \cos\alpha_j &            & \bs^{m_j} s^{0+2p+0} & \partial_\s A_{\t} &                 
!latex \end{array} \ee

!latex \item The second derivative with respect to $a \equiv b_{j,p}$ and $b \equiv a_{k,q}$ is 

!latex \be \begin{array}{ccllllrccccc}
!latex \ds \frac{\partial^2 P_1}{\partial a \partial b} \!\!\!\! &\!\!=\!\!&\!\! \\
!latex &+               & \rho^{1+0+2p+0+2+2q+0} \ds \intdso m_j &            & \bs^{m_j} \bs^{2p+0} & n_k &            & \bs^{m_k} \bs^{2+2q+0} & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex &+               & \rho^{1+0+2p-1+2+2q+0} \ds \intdso     & (m_j+2p  ) & \bs^{m_j} \bs^{2p-1} & n_k &            & \bs^{m_k} \bs^{2+2q+0} & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex &-               & \rho^{1+0+2p+0+2+2q-1} \ds \intdso m_j &            & \bs^{m_j} \bs^{2p+0} &     & (m_k+2+2q) & \bs^{m_k} \bs^{2+2q-1} & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex &-               & \rho^{1+0+2p-1+2+2q-1} \ds \intdso     & (m_j+2p  ) & \bs^{m_j} \bs^{2p-1} &     & (m_k+2+2q) & \bs^{m_k} \bs^{2+2q-1} & \braket{c_j}{\bar g_{\t\z}}{c_k} \\
!latex &+ \frac{\mu}{2} & \rho^{1+0+2p-1+2+2q+0} \ds \intdso     & (m_j+2p  ) & \bs^{m_j} \bs^{2p-1} &     &            & \bs^{m_k} \bs^{2+2q+0} & \braket{c_j}{     1       }{c_k} \\
!latex &- \frac{\mu}{2} & \rho^{1+0+2p+0+2+2q-1} \ds \intdso     &            & \bs^{m_j} \bs^{2p+0} &     & (m_k+2+2q) & \bs^{m_k} \bs^{2+2q-1} & \braket{c_j}{     1       }{c_k}   
!latex \end{array} \ee

!latex \item The second derivative with respect to $a \equiv b_{j,p}$ and $b \equiv b_{k,q}$ is 

!latex \be \begin{array}{ccllllllcccccclr}
!latex \ds \frac{\partial^2 P_1}{\partial a \partial b} \!\!\!\! &\!\!=\!\!&\!\! \\
!latex &+               & \rho^{1+0+2p+0+0+2q+0} \ds \intdso m_j &            & \bs^{m_j} \bs^{2p  } & m_k &            & \bs^{m_k} \bs^{2q  } & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex &+               & \rho^{1+0+2p+0+0+2q-1} \ds \intdso m_j &            & \bs^{m_j} \bs^{2p  } &     & (m_k+2q  ) & \bs^{m_k} \bs^{2q-1} & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex &+               & \rho^{1+0+2p-1+0+2q+0} \ds \intdso     & (m_j+2p  ) & \bs^{m_j} \bs^{2p-1} & m_k &            & \bs^{m_k} \bs^{2q  } & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex &+               & \rho^{1+0+2p-1+0+2q-1} \ds \intdso     & (m_j+2p  ) & \bs^{m_j} \bs^{2p-1} &     & (m_k+2q  ) & \bs^{m_k} \bs^{2q-1} & \braket{c_j}{\bar g_{\t\t}}{c_k}
!latex \end{array} \ee

!latex \heading{matrix elements near coordinate singularity}

!latex \item The first derivatives are
!latex \be \begin{array}{cccccccccccccccccc}
!latex \ds \frac{\partial}{\partial a_{j,p}     } P &=&
!latex \ds \frac{\partial}{\partial a_{j,p}} P_1 &+& \ds \sum_i {\cal A}^j_{i,p} & \ds \frac{\partial}{A_{\t,j,1,i}}P_2 & &                                      \\
!latex \ds \frac{\partial}{\partial b_{j,p}     } P &=&
!latex \ds \frac{\partial}{\partial b_{j,p}} P_1 &+& \ds \sum_i {\cal B}^j_{i,p} & \ds \frac{\partial}{A_{\z,j,1,i}}P_2 & &                                      \\
!latex \ds \frac{\partial}{\partial A_{\t,j,2,p}} P &=&
!latex \ds                                       & & \ds                         & \ds \frac{\partial}{A_{\t,j,2,p}}P_2 &+& \ds \frac{\partial}{A_{\t,j,2,p}}P_3 \\
!latex \ds \frac{\partial}{\partial A_{\z,j,2,p}} P &=&
!latex \ds                                       & & \ds                         & \ds \frac{\partial}{A_{\z,j,2,p}}P_2 &+& \ds \frac{\partial}{A_{\z,j,2,p}}P_3 
!latex \end{array} \ee

!latex \item The matrix elements required are the second derivatives, given as
!latex \be \begin{array}{cccccccccccccccccccccccc}

!latex \ds \frac{\partial}{\partial a_{k,q}     } & \ds \frac{\partial}{\partial a_{j,p}} & P &=&
!latex \ds \frac{\partial}{\partial a_{k,q}} & \ds \frac{\partial}{\partial a_{j,p}} & \ds P_1 &+&
!latex \ds \sum_{i,o} & \ds {\cal A}^k_{o,q} & \ds {\cal A}^j_{i,p} & \ds \frac{\partial}{\partial A_{\t,k,1,o}} & \ds \frac{\partial}{\partial A_{\t,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial b_{k,q}     } & \ds \frac{\partial}{\partial a_{j,p}} & P &=&
!latex \ds \frac{\partial}{\partial b_{k,q}} & \ds \frac{\partial}{\partial a_{j,p}} & \ds P_1 &+&
!latex \ds \sum_{i,o} & \ds {\cal B}^k_{o,q} & \ds {\cal A}^j_{i,p} & \ds \frac{\partial}{\partial A_{\z,k,1,o}} & \ds \frac{\partial}{\partial A_{\t,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial a_{k,q}     } & \ds \frac{\partial}{\partial b_{j,p}} & P &=&
!latex \ds \frac{\partial}{\partial a_{k,q}} & \ds \frac{\partial}{\partial b_{j,p}} & \ds P_1 &+&
!latex \ds \sum_{i,o} & \ds {\cal A}^k_{o,q} & \ds {\cal B}^j_{i,p} & \ds \frac{\partial}{\partial A_{\t,k,1,o}} & \ds \frac{\partial}{\partial A_{\z,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial b_{k,q}     } & \ds \frac{\partial}{\partial b_{j,p}} & P &=&
!latex \ds \frac{\partial}{\partial b_{k,q}} & \ds \frac{\partial}{\partial b_{j,p}} & \ds P_1 &+&
!latex \ds \sum_{i,o} & \ds {\cal B}^k_{o,q} & \ds {\cal B}^j_{i,p} & \ds \frac{\partial}{\partial A_{\z,k,1,o}} & \ds \frac{\partial}{\partial A_{\z,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial A_{\t,k,2,q}} & \ds \frac{\partial}{\partial a_{j,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{i  } & \ds                  & \ds {\cal A}^j_{i,p} & \ds \frac{\partial}{\partial A_{\t,k,2,q}} & \ds \frac{\partial}{\partial A_{\t,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial A_{\z,k,2,q}} & \ds \frac{\partial}{\partial a_{j,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{i  } & \ds                  & \ds {\cal A}^j_{i,p} & \ds \frac{\partial}{\partial A_{\z,k,2,q}} & \ds \frac{\partial}{\partial A_{\t,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial A_{\t,k,2,q}} & \ds \frac{\partial}{\partial b_{j,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{i  } & \ds                  & \ds {\cal B}^j_{i,p} & \ds \frac{\partial}{\partial A_{\t,k,2,q}} & \ds \frac{\partial}{\partial A_{\z,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial A_{\z,k,2,q}} & \ds \frac{\partial}{\partial b_{j,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{i  } & \ds                  & \ds {\cal B}^j_{i,p} & \ds \frac{\partial}{\partial A_{\z,k,2,q}} & \ds \frac{\partial}{\partial A_{\z,j,1,i}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial a_{k,q}} & \ds \frac{\partial}{\partial A_{\t,j,2,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{o  } & \ds {\cal A}^k_{o,q} &                      & \ds \frac{\partial}{\partial A_{\t,k,1,o}} & \ds \frac{\partial}{\partial A_{\t,j,2,p}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial b_{k,q}} & \ds \frac{\partial}{\partial A_{\t,j,2,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{o  } & \ds {\cal B}^k_{o,q} &                      & \ds \frac{\partial}{\partial A_{\z,k,1,o}} & \ds \frac{\partial}{\partial A_{\t,j,2,p}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial a_{k,q}} & \ds \frac{\partial}{\partial A_{\z,j,2,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{o  } & \ds {\cal A}^k_{o,q} &                      & \ds \frac{\partial}{\partial A_{\t,k,1,o}} & \ds \frac{\partial}{\partial A_{\z,j,2,p}} & \ds P_2 \\

!latex \ds \frac{\partial}{\partial b_{k,q}} & \ds \frac{\partial}{\partial A_{\z,j,2,p}} & P &=&
!latex \ds                                   & \ds                                   & \ds     & &
!latex \ds \sum_{o  } & \ds {\cal B}^k_{o,q} &                      & \ds \frac{\partial}{\partial A_{\z,k,1,o}} & \ds \frac{\partial}{\partial A_{\z,j,2,p}} & \ds P_2
!latex \end{array} \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma01ae(  Nofe )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one
  use numerical, only : vsmall, small
  use fileunits, only : ounit
  use inputlist, only : Wma01ae, Ni, mu, Ldense, Lsparse
  use cputiming, only : Tma01ae
  use allglobal, only : myid, cpus, ll, &
                        mn, im, in, At, Az, &                                  ! Fourier resolution, field variables = degrees of freedom;
                        dpflux, dtflux, &                                      ! inhomogeneous boundary conditions = enclosed fluxes; 
                        NBdof, MB, MR, &                                       ! Beltrami matrix and `right-hand-side' vector;
                        igss, igst, igsz, igtt, igtz, igzz, igoo, ijk ,&       ! metric integrals;
                        igaa, igab, igba, igbb, Ajpq, Bjpq                     ! metric integrals near coordinate axis;
                       !SCSF, irow, icol                                       ! required for sparse format;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in)  :: Nofe ! this is really global, but included in argument list to simplify allocation of dtkqdtjp, etc.

  INTEGER              :: ij, ip, ii, ik, iq, ix, jx, jk, kj, il, ir, ipm, jpm, kpm, io, oi

  INTEGER              :: njnk, njmk, mjnk, mjmk ! shorthand;

  INTEGER              :: ltj, lzj, ltk, lzk ! integer mode harmonic factors used to accomodate that the At & Az at outer boundary are not independent d.o.f.

  REAL                 :: hmul, bij, mri, symerr
  REAL                 :: dtkqdtjpPi(0:1,0:Nofe,0:1,0:Nofe), dzkqdtjpPi(0:1,0:Nofe,0:1,0:Nofe), dtkqdzjpPi(0:1,0:Nofe,0:1,0:Nofe), dzkqdzjpPi(0:1,0:Nofe,0:1,0:Nofe)

  BEGIN(ma01ae)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(ma01ae,Lsparse,this routine needs modification to compute the sparse representation of the Beltrami matrix)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  MB( 0:NBdof(ll),1:NBdof(ll) ) = zero ; MR( 0:NBdof(ll) ) = zero ! initialize summation; only MB( 1:NBdof(ll),1:NBdof(ll) ) & MR( 1:NBdof(ll) ) are required; rest is padding;

  hmul = half * mu(ll) ! shorthand;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do ij = 1 , mn ! loop over Fourier modes; first derivative;
   do ik = 1 , mn ! loop over Fourier modes; second derivative;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    jk = ijk(ij,ik) ; kj = ijk(ik,ij) ; njnk = in(ij)*in(ik) ; njmk = in(ij)*im(ik) ; mjnk = im(ij)*in(ik) ; mjmk = im(ij)*im(ik) ! shorthand;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    do ii = 1 , Ni(ll)
     
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
     do ip = 0 , Nofe ! loop over finite-element basis functions; first derivative;
      do iq = 0 , Nofe ! loop over finite-element basis functions; second derivative;
       
       
       do il = 0 , 1 ! loop over left and right derivatives; first derivative;
        do ir = 0 , 1 ! loop over left and right derivatives; second derivative;
         
         dtkqdtjpPi(il,ip,ir,iq) = njnk * igss(il,ip,ir,iq,jk)%s(ii) - in(ij) * igsz(il,ip,ir,iq,jk)%s(ii) - in(ik)*igsz(ir,iq,il,ip,kj)%s(ii) + igzz(il,ip,ir,iq,jk)%s(ii)
         
         dzkqdtjpPi(il,ip,ir,iq) = njmk * igss(il,ip,ir,iq,jk)%s(ii) + in(ij) * igst(il,ip,ir,iq,jk)%s(ii) - im(ik)*igsz(ir,iq,il,ip,kj)%s(ii) - igtz(il,ip,ir,iq,jk)%s(ii) &
                                 + hmul * igoo(il,ip,ir,iq,jk)%s(ii) -  hmul  * igoo(ir,iq,il,ip,jk)%s(ii)

         dtkqdzjpPi(il,ip,ir,iq) = mjnk * igss(il,ip,ir,iq,jk)%s(ii) + in(ik) * igst(ir,iq,il,ip,kj)%s(ii) - im(ij)*igsz(il,ip,ir,iq,jk)%s(ii) - igtz(il,ip,ir,iq,jk)%s(ii) &
                                 + hmul * igoo(ir,iq,il,ip,jk)%s(ii) -  hmul  * igoo(il,ip,ir,iq,jk)%s(ii)

         dzkqdzjpPi(il,ip,ir,iq) = mjmk * igss(il,ip,ir,iq,jk)%s(ii) + im(ij) * igst(il,ip,ir,iq,jk)%s(ii) + im(ik)*igst(ir,iq,il,ip,kj)%s(ii) + igtt(il,ip,ir,iq,jk)%s(ii)
         
        enddo ! end of do ir;
       enddo ! end of do il;
      enddo ! end of do iq; 
     enddo ! end of do ip;
     
     
     if( ll.eq.1 ) then ! need to consider the coordinate singularity;
      
      do ip = 0 , Nofe
       do iq = 0 , Nofe
        
        if( ii.eq.1 ) then 
         ix=At(ll,ij,ip)%i(ii-1) ; jx=At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + igaa(1,ip,iq,jk) - igaa(2,ip,iq,jk) - igaa(3,ip,iq,jk) + igaa(4,ip,iq,jk)
         ix=At(ll,ij,ip)%i(ii-1) ; jx=Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + igab(1,ip,iq,jk) + igab(2,ip,iq,jk) - igab(3,ip,iq,jk) - igab(4,ip,iq,jk) &
                                                                       + hmul * igab(5,ip,iq,jk) - hmul * igab(6,ip,iq,jk)
         ix=Az(ll,ij,ip)%i(ii-1) ; jx=At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + igba(1,ip,iq,jk) + igba(2,ip,iq,jk) - igba(3,ip,iq,jk) - igba(4,ip,iq,jk) &
                                                                       + hmul * igba(5,ip,iq,jk) - hmul * igba(6,ip,iq,jk)
         ix=Az(ll,ij,ip)%i(ii-1) ; jx=Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + igbb(1,ip,iq,jk) + igbb(2,ip,iq,jk) + igbb(3,ip,iq,jk) + igbb(4,ip,iq,jk)
        endif ! end of if( ii.eq.1 );
        
        if( ii.eq.2 ) then
         
           ix=At(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                                   dtkqdtjpPi( 1,ip, 1,iq)
           ix=At(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                                   dzkqdtjpPi( 1,ip, 1,iq)
           ix=Az(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                                   dtkqdzjpPi( 1,ip, 1,iq)
           ix=Az(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                                   dzkqdzjpPi( 1,ip, 1,iq)
         
         do io = 0, Nofe
          
           ix=At(ll,ij,ip)%i(ii-2) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                  Ajpq(ij,io,ip) * dtkqdtjpPi( 0,io, 1,iq)
           ix=At(ll,ij,ip)%i(ii-2) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                  Ajpq(ij,io,ip) * dzkqdtjpPi( 0,io, 1,iq)
           ix=Az(ll,ij,ip)%i(ii-2) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                  Bjpq(ij,io,ip) * dtkqdzjpPi( 0,io, 1,iq)
           ix=Az(ll,ij,ip)%i(ii-2) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) +                  Bjpq(ij,io,ip) * dzkqdzjpPi( 0,io, 1,iq)
          
           ix=At(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Ajpq(ik,io,iq)                  * dtkqdtjpPi( 1,ip, 0,io)
           ix=At(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Bjpq(ik,io,iq)                  * dzkqdtjpPi( 1,ip, 0,io)
           ix=Az(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Ajpq(ik,io,iq)                  * dtkqdzjpPi( 1,ip, 0,io)
           ix=Az(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Bjpq(ik,io,iq)                  * dzkqdzjpPi( 1,ip, 0,io)
          
          do oi = 0, Nofe

           ix=At(ll,ij,ip)%i(ii-2) ; jx=At(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Ajpq(ik,oi,iq) * Ajpq(ij,io,ip) * dtkqdtjpPi( 0,io, 0,oi)
           ix=At(ll,ij,ip)%i(ii-2) ; jx=Az(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Bjpq(ik,oi,iq) * Ajpq(ij,io,ip) * dzkqdtjpPi( 0,io, 0,oi)
           ix=Az(ll,ij,ip)%i(ii-2) ; jx=At(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Ajpq(ik,oi,iq) * Bjpq(ij,io,ip) * dtkqdzjpPi( 0,io, 0,oi)
           ix=Az(ll,ij,ip)%i(ii-2) ; jx=Az(ll,ik,iq)%i(ii-2) ; MB(ix,jx) = MB(ix,jx) + Bjpq(ik,oi,iq) * Bjpq(ij,io,ip) * dzkqdzjpPi( 0,io, 0,oi)
           
          enddo ! end of do oi;
          
         enddo ! end of do io;
         
        endif ! end of if( ii.eq.2 )
        
       enddo ! end of do iq;
      enddo ! end of do ip;
      
     endif ! end of if( ll.eq.1 );
     

     if( ll.gt.1 .or. ii.gt.2 ) then
      
      do ip = 0 , Nofe
       do iq = 0 , Nofe
        
        ltj = 1 ; lzj = 1  ; ltk = 1  ; lzk = 1
        
        if( ii.eq.Ni(ll) ) then
         
         if( ij.gt.1 .and. ip.eq.0 ) then ; ltj =  im(ij) ; lzj = -in(ij) ! this is not an independent degree of freedom;
         endif
         if( ik.gt.1 .and. iq.eq.0 ) then ; ltk =  im(ik) ; lzk = -in(ik) ! this is not an independent degree of freedom;
         endif
         
        endif ! end of if( ii.eq.Ni(ll) );
        
        ix=At(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 1,ip, 0,iq) * ltj
        ix=At(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 1,ip, 1,iq) * ltj * ltk
        ix=At(ll,ij,ip)%i(ii-1) ; jx=At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 0,ip, 0,iq)
        ix=At(ll,ij,ip)%i(ii-1) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 0,ip, 1,iq) * ltk
        
        ix=At(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 1,ip, 0,iq) * ltj
        ix=At(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 1,ip, 1,iq) * ltj * lzk
        ix=At(ll,ij,ip)%i(ii-1) ; jx=Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 0,ip, 0,iq)
        ix=At(ll,ij,ip)%i(ii-1) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 0,ip, 1,iq) * lzk
        
        ix=Az(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 1,ip, 0,iq) * lzj
        ix=Az(ll,ij,ip)%i(ii  ) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 1,ip, 1,iq) * lzj * ltk
        ix=Az(ll,ij,ip)%i(ii-1) ; jx=At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 0,ip, 0,iq)
        ix=Az(ll,ij,ip)%i(ii-1) ; jx=At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 0,ip, 1,iq) * ltk
        
        ix=Az(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 1,ip, 0,iq) * lzj
        ix=Az(ll,ij,ip)%i(ii  ) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 1,ip, 1,iq) * lzj * lzk
        ix=Az(ll,ij,ip)%i(ii-1) ; jx=Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 0,ip, 0,iq)
        ix=Az(ll,ij,ip)%i(ii-1) ; jx=Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 0,ip, 1,iq) * lzk

        if( ii.eq.Ni(ll) .and. ik.eq.1 .and. iq.eq.0 ) then ! second derivative involves inhomogeneous boundary term;

         ix=At(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dtkqdtjpPi( 0,ip, 1,iq)       * dtflux(ll)
         ix=At(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dtkqdtjpPi( 1,ip, 1,iq) * ltj * dtflux(ll)

         ix=At(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dzkqdtjpPi( 0,ip, 1,iq)       * dpflux(ll)
         ix=At(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dzkqdtjpPi( 1,ip, 1,iq) * ltj * dpflux(ll)

         ix=Az(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dtkqdzjpPi( 0,ip, 1,iq)       * dtflux(ll)
         ix=Az(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dtkqdzjpPi( 1,ip, 1,iq) * lzj * dtflux(ll)

         ix=Az(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dzkqdzjpPi( 0,ip, 1,iq)       * dpflux(ll)
         ix=Az(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dzkqdzjpPi( 1,ip, 1,iq) * lzj * dpflux(ll)

        endif ! end of inhomogeneous term;

       enddo ! end of do iq;
      enddo ! end of do ip;

     endif ! end of if( ll.gt.1 .or. ii.gt.2);
     
    enddo ! end of do ii;
    
   enddo ! end of do ik;
  enddo ! end of do ij;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!     ix = At(ll,ij,ip)%i(ii  ) ! identifies row;
!     
!       if( ix.gt.0 ) then ! this is a degree of freedom, or depends on a degree of freedom;
!        
!        if( ij.gt.1 .and. ii  .eq.Ni(ll) .and. ip.eq.0 ) then ; lmn =   im(ij) ! this is not an independent degree of freedom;
!        else                                                  ; lmn = 1
!        endif
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!        if( ik.eq.1 .and. iq.eq.0 .and. ii.eq.Ni(ll)-1) then ! outer boundary, inhomogeneous term arising from poloidal/toroidal fluxes;
!
!         mri = &
!             + in(ij)*igst(0,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - in(ij)*igsz(0,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             -        igtz(0,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igzz(0,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - hmul*( &
!             -        igoo(0,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igoo(1,iq,0,ip,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll))
!         MR(ix) = mri*lmn + MR(ix)
!         
!        endif
!
!        if( ik.eq.1 .and. iq.eq.0 .and. ii.eq.Ni(ll)  ) then ! outer boundary, inhomogeneous term arising from poloidal/toroidal fluxes;
!
!         mri = &
!             + in(ij)*igst(1,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - in(ij)*igsz(1,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             -        igtz(1,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igzz(1,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - hmul*( &
!             -        igoo(1,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igoo(1,iq,1,ip,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll))
!         MR(ix) = mri*lmn + MR(ix)
!         
!        endif
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
!        jx = At(ll,ik,iq)%i(ii-1) ! identifies col; (0,1); recall that At(ll,ik,iq)%i(-1:Ni(ll)+1) includes "padding" for simple loop logic;
!        
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii-1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn =   im(ik)
!         else                                                   ; rmn = 1
!         endif
!  
!         if( ii  .ge. 2     ) bij = bij + njnk*igss(1,ip,0,iq,jk)%s(ii  ) - in(ij)*igsz(1,ip,0,iq,jk)%s(ii  ) - in(ik)*igsz(0,iq,1,ip,jk)%s(ii  ) + igzz(1,ip,0,iq,jk)%s(ii  )
!         
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!         
!        endif ! end of if( jx.gt.0 );
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
!        jx = At(ll,ik,iq)%i(ii  ) ! identifies col; (0,2);
!        
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii  .eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn =   im(ik)
!         else                                                   ; rmn = 1
!         endif
!  
!         if( ii  .eq. 0     ) bij = bij + igaa(1,ip,iq,jk) - igaa(2,ip,iq,jk) - igaa(3,ip,iq,jk) + igaa(4,ip,iq,jk) ! regularity term;
!       
!         if( ii  .ge. 2     ) bij = bij + njnk*igss(1,ip,1,iq,jk)%s(ii  ) - in(ij)*igsz(1,ip,1,iq,jk)%s(ii  ) - in(ik)*igsz(1,iq,1,ip,kj)%s(ii  ) + igzz(1,ip,1,iq,jk)%s(ii  ) 
!         if( ii+1.le.Ni(ll) ) bij = bij + njnk*igss(0,ip,0,iq,jk)%s(ii+1) - in(ij)*igsz(0,ip,0,iq,jk)%s(ii+1) - in(ik)*igsz(0,iq,0,ip,kj)%s(ii+1) + igzz(0,ip,0,iq,jk)%s(ii+1)
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!         
!        endif ! end of if( jx.gt.0 );
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
!        jx = At(ll,ik,iq)%i(ii+1) ! identifies col; (0,3);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii+1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn =   im(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!         
!         if( ii+1.le.Ni(ll) ) bij = bij + njnk*igss(0,ip,1,iq,jk)%s(ii+1) - in(ij)*igsz(0,ip,1,iq,jk)%s(ii+1) - in(ik)*igsz(1,iq,0,ip,kj)%s(ii+1) + igzz(0,ip,1,iq,jk)%s(ii+1)  
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!         
!        endif ! end of if( jx.gt.0 );
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
!        jx = Az(ll,ik,iq)%i(ii-1) ! identifies col; (0,4);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii-1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn = - in(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!         
!         if( ii  .ge. 2     ) bij = bij + njmk*igss(1,ip,0,iq,jk)%s(ii  ) + in(ij)*igst(1,ip,0,iq,jk)%s(ii  ) - im(ik)*igsz(0,iq,1,ip,kj)%s(ii  ) - igtz(1,ip,0,iq,jk)%s(ii  )
!         if( ii  .ge. 2     ) bij = bij - hmul*( - igoo(1,ip,0,iq,jk)%s(ii  ) + igoo(0,iq,1,ip,jk)%s(ii  ) )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!         
!        endif ! end of if( jx.gt.0 );
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
!        jx = Az(ll,ik,iq)%i(ii  ) ! identifies col; (0,5);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii  .eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn = - in(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!         
!         if( ii  .eq. 0     ) bij = bij + igab(1,ip,iq,jk) + igab(2,ip,iq,jk) - igab(3,ip,iq,jk) - igab(4,ip,iq,jk) - hmul * ( - igab(5,ip,iq,jk) + igab(6,ip,iq,jk) )
!
!         if( ii  .ge. 2     ) bij = bij + njmk*igss(1,ip,1,iq,jk)%s(ii  ) + in(ij)*igst(1,ip,1,iq,jk)%s(ii  ) - im(ik)*igsz(1,iq,1,ip,kj)%s(ii  ) - igtz(1,ip,1,iq,jk)%s(ii  )
!         if( ii+1.le.Ni(ll) ) bij = bij + njmk*igss(0,ip,0,iq,jk)%s(ii+1) + in(ij)*igst(0,ip,0,iq,jk)%s(ii+1) - im(ik)*igsz(0,iq,0,ip,kj)%s(ii+1) - igtz(0,ip,0,iq,jk)%s(ii+1)
!         if( ii  .ge. 2     ) bij = bij - hmul*( - igoo(1,ip,1,iq,jk)%s(ii  ) + igoo(1,iq,1,ip,jk)%s(ii  ) )
!         if( ii+1.le.Ni(ll) ) bij = bij - hmul*( - igoo(0,ip,0,iq,jk)%s(ii+1) + igoo(0,iq,0,ip,jk)%s(ii+1) )
!         
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
!        jx = Az(ll,ik,iq)%i(ii+1) ! identifies col; (0,6);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii+1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn = - in(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!
!         if( ii+1.le.Ni(ll) ) bij = bij + njmk*igss(0,ip,1,iq,jk)%s(ii+1) + in(ij)*igst(0,ip,1,iq,jk)%s(ii+1) - im(ik)*igsz(1,iq,0,ip,kj)%s(ii+1) - igtz(0,ip,1,iq,jk)%s(ii+1)
!         if( ii+1.le.Ni(ll) ) bij = bij - hmul*( - igoo(0,ip,1,iq,jk)%s(ii+1) + igoo(1,iq,0,ip,jk)%s(ii+1) )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!       endif ! end of if( ix.gt.0 );
       
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
       
!       ix = Az(ll,ij,ip)%i(ii  ) ! identifies row;
!       
!       if( ix.gt.0 ) then ! this is a degree of freedom; or depends on a degree of freedom;
!
!        if( ij.gt.1 .and. ii  .eq.Ni(ll) .and. ip.eq.0 ) then ; lmn = - in(ij) ! Az(ll,ij,ip) at s = s_l is not an independent degree of freedom;
!        else                                                  ; lmn = 1
!        endif
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
!        if( ik.eq.1 .and. iq.eq.0 .and. ii.eq.Ni(ll)-1) then ! outer boundary, inhomogeneous term arising from poloidal/toroidal fluxes;
!
!         mri = &
!             + im(ij)*igst(0,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - im(ij)*igsz(0,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igtt(0,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             -        igtz(0,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - hmul*( &
!             -        igoo(1,iq,0,ip,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igoo(0,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll))
!         MR(ix) = mri*lmn + MR(ix)
!         
!        endif
!
!        if( ik.eq.1 .and. iq.eq.0 .and. ii.eq.Ni(ll)  ) then ! outer boundary, inhomogeneous term arising from poloidal/toroidal fluxes;
!
!         mri = &
!             + im(ij)*igst(1,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - im(ij)*igsz(1,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igtt(1,ip,1,iq,jk)%s(Ni(ll))*dpflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             -        igtz(1,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             - hmul*( &
!             -        igoo(1,iq,1,ip,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             +        igoo(1,ip,1,iq,jk)%s(Ni(ll))*dtflux(ll  ) & ! take care: this must be consistent with the unpacking/packing routines, up00aa;
!             )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll))
!         MR(ix) = mri*lmn + MR(ix)
!         
!        endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!        jx = At(ll,ik,iq)%i(ii-1) ! identifies col; (1,1);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii-1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn =   im(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!
!         if( ii  .ge. 2     ) bij = bij + mjnk*igss(1,ip,0,iq,jk)%s(ii  ) + in(ik)*igst(0,iq,1,ip,kj)%s(ii  ) - im(ij)*igsz(1,ip,0,iq,jk)%s(ii  ) - igtz(1,ip,0,iq,jk)%s(ii  )
!         if( ii  .ge. 2     ) bij = bij - hmul*( - igoo(0,iq,1,ip,jk)%s(ii  ) + igoo(1,ip,0,iq,jk)%s(ii  ) )
!         
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!        jx = At(ll,ik,iq)%i(ii  ) ! identifies col; (1,2);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii  .eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn =   im(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!
!         if( ii  .eq. 0     ) bij = bij + igba(1,ip,iq,jk) + igba(2,ip,iq,jk) - igba(3,ip,iq,jk) - igba(4,ip,iq,jk) - hmul * ( - igba(5,ip,iq,jk) + igba(6,ip,iq,jk) )
!
!         if( ii  .ge. 2     ) bij = bij + mjnk*igss(1,ip,1,iq,jk)%s(ii  ) + in(ik)*igst(1,iq,1,ip,kj)%s(ii  ) - im(ij)*igsz(1,ip,1,iq,jk)%s(ii  ) - igtz(1,ip,1,iq,jk)%s(ii  )
!         if( ii+1.le.Ni(ll) ) bij = bij + mjnk*igss(0,ip,0,iq,jk)%s(ii+1) + in(ik)*igst(0,iq,0,ip,kj)%s(ii+1) - im(ij)*igsz(0,ip,0,iq,jk)%s(ii+1) - igtz(0,ip,0,iq,jk)%s(ii+1)
!         if( ii  .ge. 2     ) bij = bij - hmul*( - igoo(1,iq,1,ip,jk)%s(ii  ) + igoo(1,ip,1,iq,jk)%s(ii  ) )
!         if( ii+1.le.Ni(ll) ) bij = bij - hmul*( - igoo(0,iq,0,ip,jk)%s(ii+1) + igoo(0,ip,0,iq,jk)%s(ii+1) )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!        jx = At(ll,ik,iq)%i(ii+1) ! identifies col; (1,3);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii+1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn =   im(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!
!         if( ii+1.le.Ni(ll) ) bij = bij + mjnk*igss(0,ip,1,iq,jk)%s(ii+1) + in(ik)*igst(1,iq,0,ip,kj)%s(ii+1) - im(ij)*igsz(0,ip,1,iq,jk)%s(ii+1) - igtz(0,ip,1,iq,jk)%s(ii+1)
!         if( ii+1.le.Ni(ll) ) bij = bij - hmul*( - igoo(1,iq,0,ip,jk)%s(ii+1) + igoo(0,ip,1,iq,jk)%s(ii+1) )
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!        jx = Az(ll,ik,iq)%i(ii-1) ! identifies col; (1,4);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii-1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn = - in(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!
!         if( ii  .ge. 2     ) bij = bij + mjmk*igss(1,ip,0,iq,jk)%s(ii  ) + im(ij)*igst(1,ip,0,iq,jk)%s(ii  ) + im(ik)*igst(0,iq,1,ip,kj)%s(ii  ) + igtt(1,ip,0,iq,jk)%s(ii  ) 
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!        jx = Az(ll,ik,iq)%i(ii  ) ! identifies col; (1,5);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii  .eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn = - in(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!
!         if( ii  .eq. 0     ) bij = bij + igbb(1,ip,iq,jk) + igbb(2,ip,iq,jk) + igbb(3,ip,iq,jk) + igbb(4,ip,iq,jk)
!
!         if( ii  .ge. 2     ) bij = bij + mjmk*igss(1,ip,1,iq,jk)%s(ii  ) + im(ij)*igst(1,ip,1,iq,jk)%s(ii  ) + im(ik)*igst(1,iq,1,ip,kj)%s(ii  ) + igtt(1,ip,1,iq,jk)%s(ii  )
!         if( ii+1.le.Ni(ll) ) bij = bij + mjmk*igss(0,ip,0,iq,jk)%s(ii+1) + im(ij)*igst(0,ip,0,iq,jk)%s(ii+1) + im(ik)*igst(0,iq,0,ip,kj)%s(ii+1) + igtt(0,ip,0,iq,jk)%s(ii+1)
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!        jx = Az(ll,ik,iq)%i(ii+1) ! identifies col; (1,6);
!
!        if( jx.gt.0 ) then ; bij = zero ! this is a degree of freedom;
!
!         if( ik.gt.1 .and. ii+1.eq.Ni(ll) .and. iq.eq. 0 ) then ; rmn = - in(ik) ! Az(ll,ik,iq) at s = s_l is not an independent degree of freedom;
!         else                                                   ; rmn = 1
!         endif
!
!         if( ii+1.le.Ni(ll) ) bij = bij + mjmk*igss(0,ip,1,iq,jk)%s(ii+1) + im(ij)*igst(0,ip,1,iq,jk)%s(ii+1) + im(ik)*igst(1,iq,0,ip,kj)%s(ii+1) + igtt(0,ip,1,iq,jk)%s(ii+1) 
!
!         FATAL(ma01ae,ix.lt.1 .or. ix.gt.NBdof(ll) .or. jx.lt.1 .or. jx.gt.NBdof(ll))
!         MB(ix,jx) = bij*lmn*rmn + MB(ix,jx)
!
!        endif ! end of if( jx.gt.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!       endif ! end of if( ix.gt.0 );
       
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!      enddo ! end of do iq;
!     enddo ! end of do ik;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
!    enddo ! end of do ii
!   enddo ! end of do ip;   
!  enddo ! end of do ij;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Wma01ae ) then ; cput = MPI_WTIME()
   
  !cput = MPI_WTIME() ; write(ounit,'("ma01ae : "f10.2" : myid="i3" ; ll="i3" ; checking symmetry of MB;")')cput-cpus,myid,ll

!   do ij = 1 , mn ! loop over all;
!    do ip = 0 , Nofe ! degrees of freedom;
!     do ii = 1 , Ni(ll) ! to construct matrix elements; remember that for all ij, ip > 0, ii=0 are degrees of freedom; 
!      
!      do ik = 1 , mn ! summation loops;
!       do iq = 0 , Nofe ! summation loops;
!        
!        do kpm = 0 , 1 ! loop over first derivative, At or Az;
!
!         if( kpm.eq.0 ) ix = At(ll,ij,ip)%i(ii  ) ! identifies row;
!         if( kpm.eq.1 ) ix = Az(ll,ij,ip)%i(ii  ) ! identifies row;
!         
!         if( ix.gt.0 ) then ! this is a degree of freedom;
!         
!          do jpm = 0 , 1 ! loop over second derivative, At or Az;
!           do ipm = -1 , 1 ! loop over second derivative;
!
!            if( jpm.eq.0 ) jx = At(ll,ik,iq)%i(ii+ipm) ! identifies col;
!            if( jpm.eq.1 ) jx = Az(ll,ik,iq)%i(ii+ipm) ! identifies col;
!            
!            if( jx.gt.0 ) then ! this is a degree of freedom;
!             
!             if( abs(MB(ix,jx)-MB(jx,ix)) .gt. small ) then ! checking symmetry;
!              write(ounit,2000)cput-cpus,myid,ll,ij,ip,ii,ik,iq,kpm,jpm,ipm,ix,jx,MB(ix,jx),MB(jx,ix),jx,ix,abs(MB(ix,jx)-MB(jx,ix))
!              pause
!             endif ! end of if( abs(MB(ix,jx)-MB(jx,ix)) .gt. small ) ;
!             
!            endif ! end of if( jx.gt.0 );
!
!           enddo ! end of do ipm;
!          enddo ! end of do jpm;
!
!         endif ! end of if( ix.gt.0 );
!
!        enddo ! end of do kpm;
!
!       !pause
!
!       enddo ! end of do iq
!      enddo ! end of do ik
!
!     enddo ! end of do ii
!    enddo ! end of do ip
!   enddo ! end of do ij
!
!2000 format("ma01ae : "f10.2" : myid="i3" ; ll="i3" : ij="i3", ip="i3", ii="i3", ik="i3", iq="i3"; k,j,i="3i3" : MB("i5" ,",i5" ) = "2es23.15" = MB("i5" ,"i5" ) ; err="es9.1" ;")
   
   symerr = zero
   
   do ix = 1 , NBdof(ll)
    do jx = 1 , NBdof(ll)
     symerr = symerr + abs(MB(ix,jx)-MB(jx,ix))
    !if( abs(MB(ix,jx)-MB(jx,ix)) .gt. vsmall ) write(ounit,1000)cput-cpus,myid,ll,ix,jx,MB(ix,jx),MB(jx,ix),jx,ix,abs(MB(ix,jx)-MB(jx,ix))
    enddo
   enddo
   symerr = symerr / NBdof(ll) / NBdof(ll)
   
   cput = MPI_WTIME() ; write(ounit,'("ma01ae : "f10.2" : myid="i3" ; ll="i3" ; MB symmetry error ="es10.2" ;")')cput-cpus,myid,ll,symerr
   
1000 format("ma01ae : "f10.2" : myid="i3" ; ll="i3" ; MB("i5" ,",i5" ) = "2es23.15" = MB("i5" ,"i5" ) ; err="es10.2" ;")

  endif ! end of if( Wma01ae );
  
  RETURN(ma01ae)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ma01ae

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
