!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs matrix that represents the Beltrami linear system.

!latex \heading{gauge and boundary conditions}

!latex \item The helicity integral, $\int {\bf A}\cdot{\bf B}\, dv$, depends explicity on the vector potential.
!latex The gauge must be constrained and the boundary conditions enforced.

!latex First we consider an annular volume.

!latex \heading{annular volume - gauge}

!latex \item The coordinates, $(\s,\t,\z)$, are adapted to the interfaces, so that the interfaces coincide with coordinate surfaces $s=const.$
!latex and $\t$,$\z$ are poloidal and toroidal angles.

!latex \item In the \mbox{$l$}-th annulus, bounded by the \mbox{$(l-1)$}-th and \mbox{$l$}-th interfaces,
!latex a general covariant representation of the magnetic vector-potential is written
!latex \be {\bf \bar A}=\bar A_{s} \nabla s + \bar A_{\t} \nabla \t + \bar A_{\z} \nabla \z. \ee
!latex To this add \mbox{$\nabla g(s,\t,\z)$}, where $g$ satisfies
!latex \be \partial_\s g(\s      ,\t,\z)  =  - \bar A_{\s}(\s      ,\t,\z)             ,\;\;
!latex     \partial_\t g(\s_{l-1},\t,\z)  =  - \bar A_{\t}(\s_{l-1},\t,\z)+\psi_{t,l-1},\;\;
!latex     \partial_\z g(\s_{l-1}, 0,\z)  =  - \bar A_{\z}(\s_{l-1}, 0,\z)+\psi_{p,l-1}, \ee
!latex for arbitrary constants \mbox{$\psi_{t,l-1}$}, \mbox{$\psi_{p,l-1}$}, which are the toroidal and poloidal-fluxes on the interior of surface \mbox{$l-1$}.
!latex Then \mbox{${\bf A}={\bf \bar A}+\nabla g$} is given by \mbox{${\bf A}=A_{\t}\nabla\t+A_{\z}\nabla\z$} with
!latex \be A_{\t}(\s_{l-1},\t,\z) = \psi_{t,l-1},\;\;
!latex     A_{\z}(\s_{l-1}, 0,\z) = \psi_{p,l-1}. \label{eq:gauge} \ee
!latex This specifies the gauge.

!latex \item The magnetic field is $\sqrt g {\bf B} = (\partial_\t A_\z - \partial_\z A_\t){\bf e}_\s - \partial_\s A_\z {\bf e}_\t + \partial_\s A_\t {\bf e}_\z$.
!latex \be  B^2            &=& B^\s B^\s g_{\s\s} + 2 B^\s B^\t g_{\s\t} + 2 B^\s B^\z g_{\s\z} + B^\t B^\t g_{\t\t} + 2 B^\t B^\z g_{\t\z} + B^\z B^\z g_{\z\z}\\
!latex \sqrt g {\bf A} \cdot {\bf B} &=& -A_\t \partial_s A_\z + A_\z \partial_s A_\t.
!latex \ee

!latex \item For stellarator symmetric equilibria, \mbox{$A_{\t}$} and \mbox{$A_{\z}$} may be represented by cosine series
!latex \be A_{\t}(s,\t,\z) = \sum_{j}A_{\t,j}(s)\cos(m_j\t-n_j\z),\;\;
!latex     A_{\z}(s,\t,\z) = \sum_{j}A_{\z,j}(s)\cos(m_j\t-n_j\z),\ee
!latex where \mbox{$A_{\t,j}(s)$} and \mbox{$A_{\z,j}(s)$} are represented using finite-elements, as described below.

!latex \item Within each annulus, a regular, radial-sub-grid, $s_{l,i} \equiv$ \verb+ss(l)%s(i)+, for $i=0,$ \verb+Ni+, is established, see \verb+al00aa+.

!latex \heading{interface boundary condition}

!latex \item The condition that the field is tangential to the inner interface is
!latex \be -m_jA_{\z,j}(s_{l-1})-n_jA_{\t,j}(s_{l-1})=0. \label{eq:innersurfaceconstraint} \ee
!latex Combing the gauge constraints and the flux surface condition we have
!latex \be A_{\t,j}(s_{l-1}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{t,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \;\;\; \mbox{\rm and} \;\;\;\;
!latex     A_{\z,j}(s_{l-1}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{p,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \label{eq:innergauge}\ee

!latex \item The condition that the field is tangential to the outer interface is similar to \Eqn{innersurfaceconstraint}, but it cannot be simplified further and so
!latex at the outer interface we must constrain the vector potential to be of the form
!latex \be A_{\t}(s_{l}) = \partial_\t f(\t,\z) \, , \,\,\, A_{\z}(s_l) = \partial_\z f(\t,\z), \label{eq:outersurfaceconstraint} \ee
!latex for arbitrary \mbox{$f$} of the form
!latex \be f=\psi_{t,l} \t + \psi_{p,l} \z + \sum_j f_{l,j}\sin(m_j \t - n_j \z) \ee
!latex and \mbox{$\psi_{t,l}\equiv A_{\t,1}(s_l)$} and \mbox{$\psi_{p,l}\equiv A_{\z,1}(s_l)$}.
!latex We have
!latex \be A_{\t,j}(s_{l}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{t,l} & j=1, \\  m_j  f_{l,j} & j>1, \end{array} \right. \;\;\;\; \mbox{\rm and} \;\;\;\;
!latex     A_{\z,j}(s_{l}) = \left\{ \begin{array}{c@{\quad,\quad}c}\psi_{p,l} & j=1, \\ -n_j  f_{l,j} & j>1, \end{array} \right. \label{eq:outerboundary} \ee

!latex \heading{finite element radial basis functions}

!latex \item Within each annulus a regular, radial-sub-grid, $s_i$, is established.

!latex \item In the region $ s \in [ s_{i-1} , s_{i} ] $, the vector potential is ${\bf A}=A_\t \nabla \t + A_\z \nabla \z$ where
!latex \be A_{\t}(s,\t,\z) = \sum_{j,l,p} \, A_{\t,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) , \label{eq:finiteelementAtannular} \\
!latex     A_{\z}(s,\t,\z) = \sum_{j,l,p} \, A_{\z,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) , \label{eq:finiteelementAzannular} \ee
!latex where $j$ labels the Fourier harmonic, and $l=0,1$ and $p$ identify the radial basis functions, $\varphi_{l,p}(s)$.

!latex \item Near the coordinate singularity (described in more detail below) this representation needs to be modified.

!latex \heading{metric information}

!latex \item The geometric information required in the following is
!latex \be \bar g_{\s\s} \equiv g_{\s\s} / \sqrt g = \sum_i \bar g_{\s\s,i}(s)\cos(m_i\t-n_i\z), \\
!latex     \bar g_{\s\t} \equiv g_{\s\t} / \sqrt g = \sum_i \bar g_{\s\t,i}(s)\sin(m_i\t-n_i\z), \\
!latex     \bar g_{\s\z} \equiv g_{\s\z} / \sqrt g = \sum_i \bar g_{\s\z,i}(s)\sin(m_i\t-n_i\z), \\
!latex     \bar g_{\t\t} \equiv g_{\t\t} / \sqrt g = \sum_i \bar g_{\t\t,i}(s)\cos(m_i\t-n_i\z), \\
!latex     \bar g_{\t\z} \equiv g_{\t\z} / \sqrt g = \sum_i \bar g_{\t\z,i}(s)\cos(m_i\t-n_i\z), \\
!latex     \bar g_{\z\z} \equiv g_{\z\z} / \sqrt g = \sum_i \bar g_{\z\z,i}(s)\cos(m_i\t-n_i\z). \ee

!latex \item For any function \mbox{$f(\s,\t,\z)$}, in particular the metrics, we write
!latex \be \braket{s_j}{f}{s_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \sin(m_k\t-n_k\z) \nonumber \\
!latex     \braket{s_j}{f}{c_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \\
!latex     \braket{c_j}{f}{c_k} \! & \! = \! & \ooint \cos(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \ee

!latex \heading{volume integral}

!latex \item Consider the integral $P = \sum_{i=1}^{N_i}P_i$, where

!latex \be \begin{array}{ccccrrrr}
!latex P_i & = \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\t A_{\z} & \bar g_{\s\s} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex     &   & + & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex     &   & + & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\z} & \bar g_{\t\t} \\
!latex     &   & - & \ds               & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\t} & \bar g_{\t\z} \\
!latex     &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\t} & \partial_\s A_{\t} & \bar g_{\z\z} \\
!latex     &   & + & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} & \partial_\s A_{\z} &               \\
!latex     &   & - & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} & \partial_\s A_{\t} & .
!latex \end{array} \ee

!latex \heading{derivatives of volume integral -- annular regions}

!latex \item The first derivatives are as follows:

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\z\z} \\
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}   & c_j &               \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} &     & \varphi_{l,p}'  & c_j & 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} &     & \varphi_{l,p}'  & c_j &               \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}   & c_j & 
!latex \end{array} \ee

!latex \item The second derivatives are required for construction of the Beltrami matrix, which are given

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\z\z}}{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\t}}{c_k}
!latex \end{array} \ee

!latex \heading{matrix elements -- annular regions}

!latex \item The required matrix elements take the form, where $\a=\t,\z$ and $\b=\t,\z$,
!latex \be \begin{array}{ccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!latex \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i  } \\
!latex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!latex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i  } &+&
!latex \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i+1} \\
!latex \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P       &=&
!latex                                               &                                             &         & &
!latex \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & P_{i+1} \\
!latex \end{array} \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{gauge and regularity conditions near coordinate origin}

!latex \item Near the polar coordinate origin, which is {\em not} required to coincide with the magnetic axis (the location of which is as yet not known apriori),
!latex we may exploit the regularity constraints and gauge freedom \footnote{This was done using Mathematica, and further details will be provided on demand.} to write
!latex ${\bf A}=A_\t \nabla \t + A_\z \nabla \z$ where
!latex \be A_\t(s,\t,\z) &=& \sum_{j=1} \sum_{p=0} a_{j,p} s^{m_j+2+2p} \cos(m_j\t -n_j\z), \\
!latex     A_\z(s,\t,\z) &=& \sum_{j=1} \sum_{p=0} b_{j,p} s^{m_j+0+2p} \cos(m_j\t -n_j\z), 
!latex \ee
!latex where the $a_{j,p}$ and $b_{j,p}$ are degrees of freedom, except $b_{j,0}=0$ if $m_j=0$.

!latex \item Note that the location of the coordinate axis is determined by \verb+ex00aa+.

!latex \item The factors $s^{m_j+2}$ and $s^{m_j+0}$ can become very small and cause finite-precision errors unless treated carefully.
!latex Thus, the discretization \Eqn{finiteelementAtannular} and \Eqn{finiteelementAzannular} are modified (in the entire innermost volume) and we write
!latex \be A_{\t}(s,\t,\z) = \sum_{j,l,p} s^{m_j+2} \, A_{\t,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) , \label{eq:finiteelementAttorus} \\
!latex     A_{\z}(s,\t,\z) = \sum_{j,l,p} s^{m_j+0} \, A_{\z,j,i-1+l,p} \,\, \varphi_{l,p}(s) \, \cos(m_j\t-n_j\z) , \label{eq:finiteelementAztorus} \ee
!latex with the coordinate origin boundary condition
!latex
!latex $A_{\t,j,0,p}=0$ for $p=1,3,\dots$
!latex 
!latex $A_{\z,j,0,p}=0$ for $p=1,3,\dots$ and $A_{\z,j,0,0}=0$ for $m_j=0$.

!latex \item The second derivatives required are then

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & n_j & (s^{m_k+2} \varphi_{r,q})  & (s^{m_j+2} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & n_j & (s^{m_k+2} \varphi_{r,q})' & (s^{m_j+2} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl & n_k &     & (s^{m_k+2} \varphi_{r,q})  & (s^{m_j+2} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & (s^{m_k+2} \varphi_{r,q})' & (s^{m_j+2} \varphi_{l,p})' & \braket{c_j}{\bar g_{\z\z}}{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & n_j & (s^{m_k+0} \varphi_{r,q})  & (s^{m_j+2} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & n_j & (s^{m_k+0} \varphi_{r,q})' & (s^{m_j+2} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & (s^{m_k+0} \varphi_{r,q})  & (s^{m_j+2} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & (s^{m_k+0} \varphi_{r,q})' & (s^{m_j+2} \varphi_{l,p})' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k+0} \varphi_{r,q})' & (s^{m_j+2} \varphi_{l,p})  & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k+0} \varphi_{r,q})  & (s^{m_j+2} \varphi_{l,p})' & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & m_j & (s^{m_k+2} \varphi_{r,q})  & (s^{m_j+0} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl & n_k &     & (s^{m_k+2} \varphi_{r,q})  & (s^{m_j+0} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & m_j & (s^{m_k+2} \varphi_{r,q})' & (s^{m_j+0} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & (s^{m_k+2} \varphi_{r,q})' & (s^{m_j+0} \varphi_{l,p})' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k+2} \varphi_{r,q})  & (s^{m_j+0} \varphi_{l,p})' & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k+2} \varphi_{r,q})' & (s^{m_j+0} \varphi_{l,p})  & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} P_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & m_j & (s^{m_k+0} \varphi_{r,q})  & (s^{m_j+0} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & m_j & (s^{m_k+0} \varphi_{r,q})' & (s^{m_j+0} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & (s^{m_k+0} \varphi_{r,q})  & (s^{m_j+0} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & (s^{m_k+0} \varphi_{r,q})' & (s^{m_j+0} \varphi_{l,p})' & \braket{c_j}{\bar g_{\t\t}}{c_k}
!latex \end{array} \ee

!latex \item The outer interface boundary condition, \Eqn{outerboundary}, becomes for $j>1$,
!latex \be A_{\t,j,N,0} = m_j f_j / \rho^{m_j + 2}\;, \;\;\;\; \mbox{\rm and} \;\;\;\; A_{\z,j,N,0} = -n_j f_j / \rho^{m_j} \ee.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma01af(  Nofe )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one
  use numerical, only : vsmall, small
  use fileunits, only : ounit
  use inputlist, only : Wma01af, Ni, mu, Ldense, Lsparse
  use cputiming, only : Tma01af
  use allglobal, only : myid, cpus, ll, iss, &
                        mn, im, in, At, Az, &                                  ! Fourier resolution, field variables = degrees of freedom;
                        dpflux, dtflux, &                                      ! inhomogeneous boundary conditions = enclosed fluxes; 
                        NBdof, MB, MR, &                                       ! Beltrami matrix and `right-hand-side' vector;
                        igss, igst, igsz, igtt, igtz, igzz, igoo, ijk ,&       ! metric integrals;
                        sgss, sgst, sgsz, sgtt, sgtz, sgzz, sgoo               ! metric integrals;
                       !igaa, igab, igba, igbb, Ajpq, Bjpq                     ! metric integrals near coordinate axis;
                       !SCSF, irow, icol                                       ! required for sparse format;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in)  :: Nofe ! this is really global, but included in argument list to simplify allocation of dtkqdtjp, etc.

  INTEGER              :: ij, ik, ip, iq, il, ir, ii, ix, jx ! loop control; matrix element identification;

  INTEGER              :: jk, kj, mj, mk, nj, nk, njnk, njmk, mjnk, mjmk ! shorthand;

  INTEGER              :: ltj, lzj, ltk, lzk ! integer mode harmonic factors used to accomodate that the At & Az at outer boundary are not independent d.o.f.

  REAL                 :: rho, jrho, krho, hmul, symerr ! shorthand; error checking;

  REAL                 :: dtkqdtjpPi(0:1,0:Nofe,0:1,0:Nofe), dzkqdtjpPi(0:1,0:Nofe,0:1,0:Nofe), dtkqdzjpPi(0:1,0:Nofe,0:1,0:Nofe), dzkqdzjpPi(0:1,0:Nofe,0:1,0:Nofe)

  BEGIN(ma01af)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(ma01af,Lsparse,this routine needs modification to compute the sparse representation of the Beltrami matrix)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  MB( 0:NBdof(ll),1:NBdof(ll) ) = zero ; MR( 0:NBdof(ll) ) = zero ! initialize summation; only MB( 1:NBdof(ll),1:NBdof(ll) ) & MR( 1:NBdof(ll) ) are required; rest is padding;

  hmul = half * mu(ll) ; rho = iss(1) ! shorthand;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do ij = 1 , mn ! loop over Fourier modes; first derivative;
   do ik = 1 , mn ! loop over Fourier modes; second derivative;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    jk = ijk(ij,ik) ; kj = ijk(ik,ij) ! shorthand;
    
    mj = im(ij) ; mk = im(ik) ; nj = in(ij) ; nk = in(ik) ; njnk = nj*nk ; njmk = nj*mk ; mjnk = mj*nk ; mjmk = mj*mk ! shorthand;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    do ii = 1 , Ni(ll)
     
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
     do ip = 0 , Nofe ! loop over finite-element basis functions; first derivative;
      do iq = 0 , Nofe ! loop over finite-element basis functions; second derivative;
       
       
       do il = 0 , 1 ! loop over left and right derivatives; first derivative;
        do ir = 0 , 1 ! loop over left and right derivatives; second derivative;
         

         if( ll.eq.1 ) then
          
          dtkqdtjpPi(il,ip,ir,iq) = njnk * sgss(4,il,ip,ir,iq,jk)%s(ii) - nj * sgsz(4,il,ip,ir,iq,jk)%s(ii) - nk*sgsz(4,ir,iq,il,ip,kj)%s(ii) + sgzz(4,il,ip,ir,iq,jk)%s(ii)
          
          dzkqdtjpPi(il,ip,ir,iq) = njmk * sgss(2,il,ip,ir,iq,jk)%s(ii) + nj * sgst(2,il,ip,ir,iq,jk)%s(ii) - mk*sgsz(3,ir,iq,il,ip,kj)%s(ii) - sgtz(2,il,ip,ir,iq,jk)%s(ii) &
                                  + hmul * sgoo(2,il,ip,ir,iq,jk)%s(ii) -  hmul  * sgoo(3,ir,iq,il,ip,kj)%s(ii)

          dtkqdzjpPi(il,ip,ir,iq) = mjnk * sgss(3,il,ip,ir,iq,jk)%s(ii) + nk * sgst(2,ir,iq,il,ip,kj)%s(ii) - mj*sgsz(3,il,ip,ir,iq,jk)%s(ii) - sgtz(3,il,ip,ir,iq,jk)%s(ii) &
                                  + hmul * sgoo(2,ir,iq,il,ip,kj)%s(ii) -  hmul  * sgoo(3,il,ip,ir,iq,jk)%s(ii)

          dzkqdzjpPi(il,ip,ir,iq) = mjmk * sgss(1,il,ip,ir,iq,jk)%s(ii) + mj * sgst(1,il,ip,ir,iq,jk)%s(ii) + mk*sgst(1,ir,iq,il,ip,kj)%s(ii) + sgtt(1,il,ip,ir,iq,jk)%s(ii)
          
         else
          
          dtkqdtjpPi(il,ip,ir,iq) = njnk * igss(il,ip,ir,iq,jk)%s(ii) - nj * igsz(il,ip,ir,iq,jk)%s(ii) - nk*igsz(ir,iq,il,ip,kj)%s(ii) + igzz(il,ip,ir,iq,jk)%s(ii)
         
          dzkqdtjpPi(il,ip,ir,iq) = njmk * igss(il,ip,ir,iq,jk)%s(ii) + nj * igst(il,ip,ir,iq,jk)%s(ii) - mk*igsz(ir,iq,il,ip,kj)%s(ii) - igtz(il,ip,ir,iq,jk)%s(ii) &
                                  + hmul * igoo(il,ip,ir,iq,jk)%s(ii) -  hmul  * igoo(ir,iq,il,ip,jk)%s(ii)

          dtkqdzjpPi(il,ip,ir,iq) = mjnk * igss(il,ip,ir,iq,jk)%s(ii) + nk * igst(ir,iq,il,ip,kj)%s(ii) - mj*igsz(il,ip,ir,iq,jk)%s(ii) - igtz(il,ip,ir,iq,jk)%s(ii) &
                                  + hmul * igoo(ir,iq,il,ip,jk)%s(ii) -  hmul  * igoo(il,ip,ir,iq,jk)%s(ii)

          dzkqdzjpPi(il,ip,ir,iq) = mjmk * igss(il,ip,ir,iq,jk)%s(ii) + mj * igst(il,ip,ir,iq,jk)%s(ii) + mk*igst(ir,iq,il,ip,kj)%s(ii) + igtt(il,ip,ir,iq,jk)%s(ii)
         
         endif

        enddo ! end of do ir;
       enddo ! end of do il;
     

      enddo ! end of do iq; 
     enddo ! end of do ip;


     
     do ip = 0 , Nofe
      do iq = 0 , Nofe
       
       ltj = 1 ; lzj = 1 ; jrho = one
       ltk = 1 ; lzk = 1 ; krho = one
       
       if( ii.eq.Ni(ll) ) then ! need to consider boundary constraints;
                
        if( ij.gt.1 .and. ip.eq.0 ) then ; ltj =  im(ij) ; lzj = -in(ij)   ! the A_{t,j}  = m_j f_j and the A_{z,j} = -n_j f_j are related;
        endif

        if( ll.eq.1 ) jrho = rho**2     ! additional radial factor must be included;

        if( ik.gt.1 .and. iq.eq.0 ) then ; ltk =  im(ik) ; lzk = -in(ik)
        endif

        if( ll.eq.1 ) krho = rho**2

!        if( ij.gt.1 .and. ip.eq.0 ) then ! this is not an independent degree of freedom;
!         ltj =  im(ij) ; lzj = -in(ij)   ! the A_{t,j}  = m_j f_j and the A_{z,j} = -n_j f_j are related;
!         if( ll.eq.1 ) jrho = rho**2     ! additional radial factor must be included;
!        endif
!
!        if( ik.gt.1 .and. iq.eq.0 ) then
!         ltk =  im(ik) ; lzk = -in(ik)
!         if( ll.eq.1 ) krho = rho**2
!        endif
        
       endif ! end of if( ii.eq.Ni(ll) );
       
       ix = At(ll,ij,ip)%i(ii  ) ; jx = At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 1,ip, 0,iq) * ( ltj / jrho )
       ix = At(ll,ij,ip)%i(ii  ) ; jx = At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 1,ip, 1,iq) * ( ltj / jrho ) * ( ltk / krho )
       ix = At(ll,ij,ip)%i(ii-1) ; jx = At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 0,ip, 0,iq)
       ix = At(ll,ij,ip)%i(ii-1) ; jx = At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdtjpPi( 0,ip, 1,iq)                  * ( ltk / krho )
       
       ix = At(ll,ij,ip)%i(ii  ) ; jx = Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 1,ip, 0,iq) * ( ltj / jrho )
       ix = At(ll,ij,ip)%i(ii  ) ; jx = Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 1,ip, 1,iq) * ( ltj / jrho ) * ( lzk        )
       ix = At(ll,ij,ip)%i(ii-1) ; jx = Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 0,ip, 0,iq)
       ix = At(ll,ij,ip)%i(ii-1) ; jx = Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdtjpPi( 0,ip, 1,iq)                  * ( lzk        )
       
       ix = Az(ll,ij,ip)%i(ii  ) ; jx = At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 1,ip, 0,iq) * ( lzj        )
       ix = Az(ll,ij,ip)%i(ii  ) ; jx = At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 1,ip, 1,iq) * ( lzj        ) * ( ltk / krho )
       ix = Az(ll,ij,ip)%i(ii-1) ; jx = At(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 0,ip, 0,iq)
       ix = Az(ll,ij,ip)%i(ii-1) ; jx = At(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dtkqdzjpPi( 0,ip, 1,iq)                  * ( ltk / krho )
       
       ix = Az(ll,ij,ip)%i(ii  ) ; jx = Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 1,ip, 0,iq) * ( lzj        )
       ix = Az(ll,ij,ip)%i(ii  ) ; jx = Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 1,ip, 1,iq) * ( lzj        ) * ( lzk        )
       ix = Az(ll,ij,ip)%i(ii-1) ; jx = Az(ll,ik,iq)%i(ii-1) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 0,ip, 0,iq)
       ix = Az(ll,ij,ip)%i(ii-1) ; jx = Az(ll,ik,iq)%i(ii  ) ; MB(ix,jx) = MB(ix,jx) + dzkqdzjpPi( 0,ip, 1,iq)                  * ( lzk        )
       
       if( ii.eq.Ni(ll) .and. ik.eq.1 .and. iq.eq.0 ) then ! second derivative involves inhomogeneous boundary term;
        
        ix = At(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dtkqdtjpPi( 0,ip, 1,iq) * dtflux(ll) / krho
        ix = At(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dtkqdtjpPi( 1,ip, 1,iq) * dtflux(ll) / krho * ( ltj / jrho ) 
        
        ix = At(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dzkqdtjpPi( 0,ip, 1,iq) * dpflux(ll)
        ix = At(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dzkqdtjpPi( 1,ip, 1,iq) * dpflux(ll) * ( ltj / jrho )
        
        ix = Az(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dtkqdzjpPi( 0,ip, 1,iq) * dtflux(ll) / krho
        ix = Az(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dtkqdzjpPi( 1,ip, 1,iq) * dtflux(ll) / krho * ( lzj        )
        
        ix = Az(ll,ij,ip)%i(ii-1) ; MR(ix) = MR(ix) + dzkqdzjpPi( 0,ip, 1,iq) * dpflux(ll)
        ix = Az(ll,ij,ip)%i(ii  ) ; MR(ix) = MR(ix) + dzkqdzjpPi( 1,ip, 1,iq) * dpflux(ll) * ( lzj        )
        
       endif ! end of inhomogeneous term;
       
      enddo ! end of do iq;
     enddo ! end of do ip;
     
    enddo ! end of do ii;
    
   enddo ! end of do ik;
  enddo ! end of do ij;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wma01af ) then ; cput = MPI_WTIME()

   symerr = zero
   
   do ix = 1 , NBdof(ll)
    do jx = 1 , NBdof(ll)
     symerr = symerr + abs(MB(ix,jx)-MB(jx,ix))
    !if( abs(MB(ix,jx)-MB(jx,ix)) .gt. vsmall ) write(ounit,1000)cput-cpus,myid,ll,ix,jx,MB(ix,jx),MB(jx,ix),jx,ix,abs(MB(ix,jx)-MB(jx,ix))
    enddo
   enddo
   symerr = symerr / NBdof(ll) / NBdof(ll)
   
   cput = MPI_WTIME() ; write(ounit,'("ma01af : "f10.2" : myid="i3" ; ll="i3" ; MB symmetry error ="es10.2" ;")')cput-cpus,myid,ll,symerr
   
1000 format("ma01af : "f10.2" : myid="i3" ; ll="i3" ; MB("i5" ,",i5" ) = "2es23.15" = MB("i5" ,"i5" ) ; err="es10.2" ;")

  endif ! end of if( Wma01af );
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(ma01af)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ma01af

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
