!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Checks pressure balance across arbitrary surface. 
!latex Input is the surface geometry, and the surface potentials.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pj00aa( mn , Rmn , Zmn , Itori , Gpoli , fmni , presi , Itoro , Gpolo , fmno , preso , sumerr )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, two, pi2, half
  use fileunits, only : ounit
  use numerical, only :
  use inputlist, only : Wpj00aa
  use cputiming, only : Tpj00aa
  use allglobal, only : myid, cpus, im, in, pi2nfp, Nt, Nz, Ntz

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: mn
  REAL, intent(in) :: Rmn(mn),Zmn(mn),Itori,Gpoli,fmni(mn),Itoro,Gpolo,fmno(mn),presi,preso
  REAL, intent(out) :: sumerr(2)

  INTEGER :: j,k,imn
  REAL :: stz(1:3),dR(0:3),dZ(0:3),fi(0:3),fo(0:3),gl(3,3),cs(2),arg,Bsqdi,Bsqdo

  BEGIN(pj00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  sumerr(1:2) = (/ zero , zero /)

  do k = 0,Nz-1
   do j = 0,Nt-1

    stz(2:3)=(/ j , k /) * (/ pi2 , pi2nfp /) / (/ Nt , Nz /)

    dR=zero ; dZ=zero ; fi = (/ zero , zero , Itori , Gpoli /) ; fo = (/ zero , zero , Itoro , Gpolo /)

    do imn=1,mn

     arg=im(imn)*stz(2)-in(imn)*stz(3) ; cs=(/cos(arg),sin(arg)/)

     dR(0)=dR(0)+ Rmn(imn)*cs(1)
     dR(2)=dR(2)+ Rmn(imn)*cs(2)*(-im(imn))
     dR(3)=dR(3)+ Rmn(imn)*cs(2)*(+in(imn))

     dZ(0)=dZ(0)+ Zmn(imn)*cs(2)
     dZ(2)=dZ(2)+ Zmn(imn)*cs(1)*(+im(imn))
     dZ(3)=dZ(3)+ Zmn(imn)*cs(1)*(-in(imn))

!latex \item The covariant components of the tangential field are given by a surface potential
!latex $B_\theta=\partial_\theta f$, $B_\phi=\partial_\phi f$, and $B_s$ is determined from
!latex \be B^s=g^{ss}B_s + g^{s\theta}B_\theta+g^{s\phi}B_\phi=0.\ee

    !fi(0)=fi(0)+fmni(imn)*cs(2)                                
     fi(2)=fi(2)+fmni(imn)*cs(1)*(+im(imn))
     fi(3)=fi(3)+fmni(imn)*cs(1)*(-in(imn))

    !fo(0)=fo(0)+fmno(imn)*cs(2)                                
     fo(2)=fo(2)+fmno(imn)*cs(1)*(+im(imn))
     fo(3)=fo(3)+fmno(imn)*cs(1)*(-in(imn))

    enddo ! end of do imn=1,mn ;

   !gl(1,1)=dR(1)*dR(1)         +dZ(1)*dZ(1) ! g_s,s
   !gl(1,2)=dR(1)*dR(2)         +dZ(1)*dZ(2) ! g_s,t
   !gl(1,3)=dR(1)*dR(3)         +dZ(1)*dZ(3) ! g_s,z
   !gl(2,1)=gl(1,2)                          ! g_t,s
    gl(2,2)=dR(2)*dR(2)         +dZ(2)*dZ(2) ! g_t,t
    gl(2,3)=dR(2)*dR(3)         +dZ(2)*dZ(3) ! g_t,z
   !gl(3,1)=gl(1,3)                          ! g_z,z
    gl(3,2)=gl(2,3)                          ! g_z,z
    gl(3,3)=dR(3)*dR(3)+dR(0)**2+dZ(3)*dZ(3) ! g_z,z

!latex \item With $B^s=0$ on the interface, the expresion for $B^2$ can be written
!latex \be B^2 = \frac{ g_{\phi  \phi  } B_\theta B_\theta - 2 g_{\theta\phi} B_\theta B_\phi + g_{\theta\theta} B_\phi B_\phi}
!latex                { g_{\theta\theta} g_{\phi\phi} - g_{\theta\phi} g_{\theta\phi} } \ee

   !write(ounit,'("pj00aa : "9x"  : (R,Z)=("2f9.5"); gl="4f15.10" Btz,Btz="4f15.10)')dR(0),dZ(0),gl(2:3,2:3),fi(2:3),fo(2:3)
    
    Bsqdi = ( gl(3,3)*fi(2)*fi(2) - two*gl(2,3)*fi(2)*fi(3) + gl(2,2)*fi(3)*fi(3) ) / ( gl(2,2)*gl(3,3)-gl(2,3)*gl(3,2) )
    Bsqdo = ( gl(3,3)*fo(2)*fo(2) - two*gl(2,3)*fo(2)*fo(3) + gl(2,2)*fo(3)*fo(3) ) / ( gl(2,2)*gl(3,3)-gl(2,3)*gl(3,2) )

    sumerr(1) = sumerr(1) +   two * presi + Bsqdi + two * preso + Bsqdo 
    sumerr(2) = sumerr(2) + ( two * presi + Bsqdi - two * preso - Bsqdo )**2
    
!    write(ounit,1001)stz(2:3),Bsqdi-Bsqdo,(Bsqdi+Bsqdo)*half
!1001 format("pj00aa : "9x"  : ("f15.10","f15.10") : force imbalance= "es12.5" ; average magnetic pressure="es12.5" ;")

   enddo ! end of poloidal grid loop
  enddo ! end of toroidal grid loop
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  sumerr(1) = half * sumerr(1) / Ntz
  sumerr(2) = sqrt(  sumerr(2) / Ntz )

! call cputime(cput)
! write(ounit,'("pj00aa : "f10.2" : err="es10.2" ;")')cput-cpus,err
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(pj00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine pj00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
