!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs \Poincare plot and `approximate' rotational-transform.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pp00aa
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, pi2
  use numerical, only :
  use fileunits, only : ounit, poincareunit
  use inputlist, only : Wpp00aa, Nvol, Ni, ext, odetol, nPpts, nPtrj, npq, Nghd
  use cputiming, only : Tpp00aa
  use allglobal, only : myid, numprocs, ll, cpus, Nz, ss, pi2nfp, sfliota, pqorbit, qfms
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER           :: id02bjf, ii, jj, kk, iigh, lnPtrj, lnPpts, nc, nqfmsok
  REAL              :: ppt(1:4)
  REAL, allocatable :: fli(:,:), qfmsst(:,:)

  INTEGER           :: Node
  REAL              :: zst, zend, st(6), sti(2), work6(20*6), tol, stz(3), RpZ(3), jacobian, lgij(6), dR(0:3), dZ(0:3), LS(5)
  REAL, allocatable :: wdata(:,:) ! for writing blocks to poincare unit;
  CHARACTER         :: RA, suf*4

  external          :: bf00aa, bf00aa_out, bf00aa_end

  BEGIN(pp00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{logical control}

!latex \item Resolution of \Poincare plot is controlled by 
!latex \begin{itemize} 
!latex \item \verb+nPtraj+ trajectories will be located in each volume;
!latex \item \verb+nPpts+ iterations per trajectory;
!latex \item \verb+odetol+ o.d.e. integration tolerance;
!latex \end{itemize}
!latex The magnetic field (and tangent field) is given by \verb+bf00aa+.

!latex \item Additional trajectories are followed inside the islands; only if the quadratic-flux minimizing surfaces have been constructed.

  if( nPtrj(ll).ge.0 ) then ; lnPtrj = nPtrj(ll) ! selected Poincare resolution;
  else                      ; lnPtrj = Ni(ll)    ! adapted  Poincare resolution;
  endif
  
  if( lnPtrj.le.0 ) goto 9999 ! return;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The approximate rotational transform is determined by field line integration.
!latex This is constructed by fitting a least squares fit to the field line trajectory.

  RALLOCATE(fli,(0:lnPtrj,1:2))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RALLOCATE(wdata,(5,0:Nz-1)) ! for block writing to file (allows faster reading for post-processing plotting routines);
  
  RALLOCATE(qfmsst,(0:Nghd*npq(ll)-1,1:2))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item The \Poincare data is written to \verb+.ext.poincare:xxxx+, where \verb+xxxx+ is an integer indicating the volume.
  write(suf,'(i4.4)')ll
  open(poincareunit+myid,file="."//trim(ext)//".poincare:"//suf,status="unknown",form="unformatted") ! this will contain Poincare plot data; 
  write(poincareunit+myid)ss(ll)%s(0),ss(ll)%s(Ni(ll)) ! identify annulus;
  write(poincareunit+myid)Nz                           ! #toroidal planes;
  
  if( Wpp00aa ) then
   cput = MPI_WTIME() ; write(ounit,'("pp00aa : "f10.2" : myid="i3" ; ll="i3" ; lnPtrj="i3" , nPpts="i5" ; odetol="es8.1" ;")')cput-cpus,myid,ll,lnPtrj,nPpts,odetol
  endif
  
! latex \item \verb+if(Nghd.eq.0)+, then quadratic-flux minimizing surfaces (should) have been constructed.
  
  nqfmsok = 0
  if( Nghd.gt.0 ) then
   do nc = 1,npq(ll)
    if( qfms(ll,1)%i.eq.1 ) then
     nqfmsok = nqfmsok + qfms(ll,1)%i ! count how many qfms surfaces successfully constructed;
    !if( Wpp00aa ) then
    ! cput = MPI_WTIME()
    ! write(ounit,'("pp00aa : "f10.2" : myid="i3" ; Nghd, nqfmsok="2i3" ; shape conformance : "3i9)')cput-cpus,myid,Nghd,nqfmsok,Nghd*nqfmsok-Nghd,Nghd*nqfmsok-1
    !endif
     qfmsst( Nghd*nqfmsok-Nghd:Nghd*nqfmsok-1,1 ) = qfms(ll,nc)%trvs(2,0:4*Nghd-1:4,0)
     qfmsst( Nghd*nqfmsok-Nghd:Nghd*nqfmsok-1,2 ) = qfms(ll,nc)%trvs(1,0:4*Nghd-1:4,0)
    endif
   enddo
  endif
  
  do ii = - Nghd*nqfmsok , lnPtrj ; iigh = ii + Nghd*nqfmsok ! loop over trajectories;
   
   Node=6 ; RA='D' ; tol=odetol
   
   if( ii.lt.0 ) then
    st(1:6) = (/ qfmsst(iigh,1) , qfmsst(iigh,2) , one , zero , zero , one /) ! first quadratic-flux minimizing surface constructed in pq02aa;
    lnPpts = 2 * nPpts
   endif
   
   if( ii.ge.0 ) then 
    st(1:6) = (/ ss(ll)%s(0) + ii * ( ss(ll)%s(Ni(ll)) - ss(ll)%s(0) ) / lnPtrj , zero , one , zero , zero , one /) ! regularly spaced starting point;
    lnPpts =      nPpts
   endif

   if( ll.eq.1 .and. ii.le.1 ) cycle ! dont follow field lines on/near coordinate axis;
   
   sti(1:2) = st(1:2)
   
   ppt(1:2) = (/ st(2) , st(1) /) ! seems redundant;
   
   LS(1:5) = (/ zero , zero , zero , ppt(1) , one /) ! initialize summations for least squares fit;
   
   do jj = 1,lnPpts ! loop over iterations;
    
    zst = zero ! starting Poincare plane;
    
    do kk = 0,Nz-1 ! loop over toroidal Poincare cross sections;
     
     stz(1:3) = (/ ppt(2) , mod(ppt(1),pi2) , zst /) ! toroidal coordinates;
     CALL(co00aa, ( stz(1:3), RpZ(1:3), dR(0:3), dZ(0:3), jacobian, lgij(1:6)) ) ! this depends on Icoords;
     ppt(3:4)=(/ RpZ(1), RpZ(3) /) ! cylindrical coordinates;
     
     wdata(1:5,kk) = (/ mod(ppt(1),pi2) , ppt(2) , ppt(3) , ppt(4) , ii*one /) ! save Poincare information to array;
     
     zend = zst + pi2nfp/Nz
    
    !if( Wpp00aa ) then ; cput = MPI_WTIME() ; write(ounit,2000)cput-cpus,myid,ll,ii,jj,kk,(/zst,zend/)/pi2nfp,st(1:2),tol
    !endif
     
     id02bjf=1
     CALL(D02BJF,(zst,zend,Node,st,bf00aa,tol,RA,bf00aa_out,bf00aa_end,work6,id02bjf))
     
    !if( Wpp00aa ) then ; cput = MPI_WTIME() ; write(ounit,2000)cput-cpus,myid,ll,ii,jj,kk,(/zst,zend/)/pi2nfp,st(1:2),tol
    !endif
    
2000 format("pp00aa : "f10.2" : myid="i3" ; ll="i3" ; (ii,jj,kk)=("i4" ,"i4" ,"i4" ); (zst,zend)/pi2nfp=("f10.6" ,"f10.6" ) ; (s,t)=("es13.5" ,"es13.5" ) ; tol="es9.1" ;")
 
     FATALMESS(pp00aa,id02bjf.eq.1,input error)
     FATALMESS(pp00aa,id02bjf.eq.2,error integrating field)
     FATALMESS(pp00aa,id02bjf.eq.3,tol is too small to take initial step)
     FATALMESS(pp00aa,id02bjf.eq.4,xsol not reset or xsol is behind x after initial call to output)
     FATALMESS(pp00aa,id02bjf.eq.5,xsol not reset or xsol is behind last xsol)
!    FATALMESS(pp00aa,id02bjf.eq.6,termination function did not change sign)
     FATALMESS(pp00aa,id02bjf.eq.7,serious error)
     
     ppt(1:2) = (/ st(2) , st(1) /) ! again, seems redundant;
     
    enddo
    
    write(poincareunit+myid)wdata
    
    LS(1:5) = LS(1:5) + (/ (jj*pi2nfp)**2 , jj*pi2nfp , jj*pi2nfp*ppt(1) , ppt(1) , one /) ! least squares fit summation;
    
   enddo ! end of do jj=1,lnPpts
   
   if( ii.ge.0 ) fli(ii,1:2) = (/ sti(1) , ( LS(5)*LS(3)-LS(2)*LS(4) ) / ( LS(5)*LS(1)-LS(2)*LS(2) ) /) ! fit straight line, least squares fit to trajectory;
   
   if( Wpp00aa ) then
    cput = MPI_WTIME()
    if( ii.eq.0                  ) write(ounit,1000)cput-cpus,myid,ll,ii,sti,fli(ii,2),sfliota(ll,0),fli(ii,2)-sfliota(ll,0) ! compare computed transform with prescribed value;
    if( ii.gt.0.and.ii.lt.lnPtrj ) write(ounit,1000)cput-cpus,myid,ll,ii,sti,fli(ii,2)
    if(             ii.eq.lnPtrj ) write(ounit,1000)cput-cpus,myid,ll,ii,sti,fli(ii,2),sfliota(ll,1),fli(ii,2)-sfliota(ll,1) ! compare computed transform with prescribed value;
1000 format("pp00aa : "f10.2" : myid="i3" ; trajectory ; ll,ii="2i6" ; (s,t)= ("2f9.5" ) ; iota="2f16.12" ("es10.2") ;")
   endif
   
  enddo ! end of do ii = - qfms(ll,1)%i * ( Nghd*2 + 1 ) , lnPtrj ; iigh = ii + ( Nghd*2 + 1 )
  
  close(poincareunit+myid)
  
  DEALLOCATE(qfmsst)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The rotational-transform data is written to \verb+.exttransform:xxxx+, where \verb+xxxx+ is an integer indicating the volume.
  
  open(poincareunit,file="."//trim(ext)//".transform:"//suf,status="unknown",form="unformatted") ! rotational transform data;
  if( ll.eq.1 ) write(poincareunit)lnPtrj
  if( ll.gt.1 ) write(poincareunit)lnPtrj+1
  write(poincareunit)ss(ll)%s(0),ss(ll)%s(Ni(ll)),sfliota(ll,0:1)
  if( ll.eq.1 ) write(poincareunit)(fli(ii,1:2),ii=1,lnPtrj)
  if( ll.gt.1 ) write(poincareunit)(fli(ii,1:2),ii=0,lnPtrj)
  close(poincareunit)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  DEALLOCATE(wdata)
  DEALLOCATE(fli)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(pp00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine pp00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


